%Ablation analysis. Check the manuscript for details.

%CMA-ES configurations
opts.LBounds=0;
opts.UBounds=50;
opts.StopFitness=1-0.95;
opts.maxiter=25;
opts.Display = 'off'; 
opts.Plotting = 'off';

opts2.LBounds=0;
opts2.UBounds=50;
opts2.StopFitness=1-0.95;
opts2.maxiter=10;
opts2.Display = 'off'; 
opts2.Plotting = 'off';

opts3.LBounds=0;
opts3.UBounds=50;
opts3.StopFitness=1-0.95;
opts3.maxiter=50;
opts3.Display = 'off'; 
opts3.Plotting = 'off';

%Algorithm Names
an={'BL*' 'CG*' 'T99' 'ContraFold' 'DIMCG' 'NOMCG' 'BL-FR*' 'MaxExpect' 'ContraFold2' 'CentroidFold'};

%Number of included algorithms
na=length(an);

%Number of lines in the input file (number of algorithms + 4 (ID, Sequence,
%Reference structure, empty line).
nl=na+4;


%index of algorithms currently included in the ensemble (will change after
%each iteration)
algoinds=1:na;


%X=cmaes('SimpleMatrixAverageFunction', [9,1,1,29,1,1,39,1,1,40.729]', 5, opts)
%unix('rm ../tmptrain.txt');
%SaveTrainSetFunction(randsample(r(1:500),500));
%[X,F,aa,bb,cc]=cmaes('SimpleMatrixAverageFunction', [ones(length(algoinds)-1,1);50], 20, opts,algoinds)


%w =[22.7978,0.0125,0,4.9429,6.1739,0.9020,34.4222,9.3005,6.9558, 48]
%X=cmaes('SimpleMatrixAverageFunction', w', 20, opts)


%Repeat until one algorithm is left.
for (i=1:na)

%Run the optimization
disp(i);
if(i==1)
  [X,F,aa,bb,cc]=cmaes('SimpleMatrixAverageFunction', [ones(length(algoinds)-1,1);50], 20, opts3,algoinds);
else
  [X,F,aa,bb,cc]=cmaes('SimpleMatrixAverageFunction', [w(1:(length(w)-1))';50], 20, opts,algoinds);
end
Xs{i}=X;
%Best F-measure
Fs{i}=1-cc.solutions.bestever.f;
%List of algorithms
Algos{i}=algoinds;
%weights
w=X(1:length(X)-1);
w(length(w)+1)=100-sum(w);
Ws{i}=w(:);


%Find the algorithm that should be removed.
RemovedIndex=1;
RemovedF=0;       
for (j=1:length(algoinds))
    disp(j);
    tmpalgoinds=[algoinds(1:(j-1)), algoinds(j+1:length(algoinds))]
    tmpw=[w(1:(j-1))', w(j+1:length(w))']
    %[X1,F1,aa1,bb1,cc1]=cmaes('SimpleMatrixAverageFunction', [ones(length(algoinds)-2,1);50], 20, opts2,tmpalgoinds);
    [X1,F1,aa1,bb1,cc1]=cmaes('SimpleMatrixAverageFunction', [tmpw(1:(length(tmpw)-1))';50], 20, opts2,tmpalgoinds);
    %F1=1-cc1.solutions.bestever.f;
    w1=X1(1:length(X1)-1);
    w1(length(w1)+1)=100-sum(w1);
    t1=X1(length(X1))
    F2=SimpleMatrixAverageFunctionFull([w1(1:(length(w1)-1))', t1]', [algoinds(1:(j-1)), algoinds(j+1:(length(algoinds)))])

    if (F2>RemovedF)
        RemovedF=F2;
        RemovedIndex=j;
    end
end
%[a,b]=max(w);

%Remove the selected algorithm
b=RemovedIndex;
RAlgos{i}=algoinds(b);

%Update the list of remaining algorithms
algoinds=[algoinds(1:(b-1)), algoinds(b+1:length(algoinds))];        

%Update the weights
w=[w(1:(b-1))', w(b+1:length(w))']
Ts{i}=X(length(X))

%Calculate the testing F-measure
F2s{i}=SimpleMatrixAverageFunctionFull([Ws{i}(1:(length(Ws{i})-1))', Ts{i}]', Algos{i})
display(sprintf('\n'));
end


  
if (0)
    Ts{na}=50;
    Fs{na}=0.6188
    F2s{na}=1-0.59667
    RAlgos{na}=3
end
    
for (i=1:na)
    display(sprintf('%s: %f', an{RAlgos{i}}, Fs{i}))
end


%make a matrix from the weights, thresholds, and train/test F-measures
dis=nan(na+3, na);
for (i=1:na)
    dis(Algos{i},i)=Ws{i};
    dis(na+1,i)=Ts{i};
    dis(na+2,i)=Fs{i};
    dis(na+3,i)=1-F2s{i};
    an2{i}=an{RAlgos{i}};
    disp(an2{i})
end

for i=1:na
    disp(an{i})
end


%dis(find(dis<0))=0;

%Write the matrix to a csv file
dlmwrite('abmat.csv', dis);
