%Given a sequence, uses indipendent programs to predict secondary
%structures. Then combines them using a predefined set of weights.

   function [output]=AveRNA(sequence, Threshold)
if (~exist('Threshold', 'var'))
    Threshold=0.42729;
end
%Algorithm Names
an={'BL*' 'CG*' 'T99' 'ContraFold' 'DIMCG' 'NOMCG' 'BL-FR*' 'MaxExpect' 'ContraFold2' 'CentroidFold'};

%Fold the sequence using the original software and parse their results
z=Parsers(sequence);

%Weights obtained from CMA-ES
w=[3.43390, 0.58136, 7.18830, 1.84120, 13.36100, 0.00000, 40.80300, 18.05200, 7.99640, 6.74250, 42.72900];

%Last number is the threshold
T=w(length(w))/100;
%Threshold=T;    

%Remove the last weight
w=w(1:length(w)-1);

%Construct the base-pair probability matrixes and average over them
output=MatrixAverage(z, w');

%Select the base pairs with probability of higher than threshold
array=zeros(1, length(output));
[a, b]=find(output>=Threshold);
if (Threshold==0)
    [a, b]=find(output>Threshold);
end
array(a)=b;

%Make the Dot-parentheses representation
output=ArraytoFolding(array);
disp('Structures predicted by the individual algorithms:\n');
for (i=1:length(z))
   disp(z{i});
end
disp('')
disp('Final Prediction:')
disp(output);

exit
