%calculate the mean F-measure for a given set of weights and algorithms
%on the SSTRAND dataset

%parameters obtained from CMA-ES
w=[3.43390, 0.58136, 7.18830, 1.84120, 13.36100, 0.00000, 40.80300, 18.05200, 7.99640, 6.74250, 42.72900]
%probability threshold
T=w(length(w))/10;
%rest of the weights
w=w(1:length(w)-1);


%Algorithm Names
an={'BL*' 'CG*' 'T99' 'ContraFold' 'DIMCG' 'NOMCG' 'BL-FR*' 'MaxExpect' 'ContraFold2' 'CentroidFold'}


%Number of lines in input file
nl=14;
%Number of algorithms
na=nl-4;

%Read the input file
input=textread('../sstrand2Structures.txt', '%s', 'delimiter', '\n', 'whitespace', '');

Fm=zeros(1,length(input)/nl);
F2m=zeros(1,length(input)/nl);

Threshold=T;    

len=length(input)/nl;

%Fmeasures will be stored here.
mat=zeros(len,length(an)+1);

for j=1:len
    
    %sequence
    sequence=input{(j-1)*nl+2};
    
    %reference structure
    originalfolding=input{(j-1)*nl+3};
    
    %calculate the F-measure for every predicted structure.
    for (i=1:na)
        output={input{(j-1)*nl+(1:na)+nl-na-1}};
        [f, s, p, TP, FP, FN]=MeasureAccuracyArray(ConvertFormat(originalfolding), ConvertFormat(output{i}));
        mat(j,i)=f;
    end

    %combine the predictions (See AveRNA.m) for more details
    output=MatrixAverage({input{(j-1)*nl+(1:na)+nl-na-1}}, w');
    array=zeros(1, length(output));
    [a, b]=find(output>=Threshold/10);
    if (Threshold==0)
        [a, b]=find(output>Threshold/10);
    end
    array=GreedyMatrixToArray(output, Threshold/10);
%    array=DPItrMatrixToArray(output, Threshold/10);


    %Calculate the F-measure of the combined prediction
    [f, s, p, TP, FP, FN]=MeasureAccuracyArray(ConvertFormat(originalfolding), array);
    mat(j,na+1)=f;
end        


%Write the output file
dlmwrite('mat.csv', mat)