%Iterative dynamic programming algorithm for inferring a secondary
%structure from a base-pair probability matrix given a threshold. For
%details please see (Lo et al. RNA, 2009).
%Returns a BPSEQ structure.
function [array] = DPItrMatrixToArray(matrix, Threshold)
n=length(matrix);
W=-ones(length(matrix), length(matrix));
for i=1:n
    W(i,i)=0;
end
array=zeros(1,length(matrix));
for i=1:(n-1)
    for j=1:(n-i)
        w=0;
        if (j==13 && i+j==17)
            [j, i+j];
        end
        %w=max(w, W(j+1,j+i)+1-sum(matrix(j,:)));
        %w=max(w, W(j,j+i-1)+1-sum(matrix(j+i,:)));
        w=max(w, W(j+1,j+i));
        w=max(w, W(j,j+i-1));
        for k=j:(j+i-1)
            w=max(w, W(j,k)+W(k+1,j+i));
        end
        if (matrix(j,j+i)>Threshold)
            tmp=matrix(j,j+i);
        else
            tmp=0;
        end
        if (w<tmp+W(j+1, j+i-1))
            %[I,J]
            array(j+i)=j;
            array(j)=j+i;
        end      
        w=max(w, tmp+W(j+1, j+i-1));
        W(j,j+i)=w;
    end
end
