%Greedy inference of a secondary structure from a base-pair probability
%matrix.
function [array] = GreedyMatrixToArray(matrix, Threshold)

%read non-zeros
[a, b]=find(matrix>0);
array=zeros(length(matrix),1);

%make the new data structure. It's basically BPSEQ with an extra column. The 3'rd
%column has the probability.
c=[a,b,zeros(length(a),1)];
for i=1:length(a)
      c(i,3)=matrix(a(i),b(i));
end

%sort it based on probability... bubble sort :P
for i=2:length(a)
    for j=1:i-1
       if (c(i,3)>c(j,3))
           temp=c(i,3);
           c(i,3)=c(j,3);
           c(j,3)=temp;
           t=c(i,2);
           c(i,2)=c(j,2);
           c(j,2)=t;
           t=c(i,1);
           c(i,1)=c(j,1);
           c(j,1)=t;
       end
    end
end


%Add base-pairs as long as they are 1) above the threshold 2)not
%conflicting
block=zeros(length(matrix),1)';
for i=1:length(a)
    if (c(i,2)<c(i,1))
        continue;
    end
    if (block(c(i,1))~=0)
        continue;
    end
    if (block(c(i,2))~=0)
        continue;
    end

    if (c(i,3)>=Threshold)
        array(c(i,1))=c(i,2);
        array(c(i,2))=c(i,1);
        block(c(i,1))=c(i,3);
        block(c(i,2))=c(i,3);
    end
    if (Threshold==0)
        if (c(i,3)>Threshold)
            array(c(i,1))=c(i,2);
            array(c(i,2))=c(i,1);            
            block(c(i,1))=c(i,3);
            block(c(i,2))=c(i,3);
        end
    end
end

%Return the BPSEQ structure
array=array'; 