%Dot paranthesis format

%Calculates F-measure, sensitivity, positive predictive value, and true
%positives, false positives, and false negatives.

function [Fmeasure, Sensitivity, PPV, TP, FP, FN] = MeasureAccuracy(originalfolding, output)

%convert to BPSEQ format:
parsedoriginalfolding=ConvertFormat(originalfolding);
parsedoutput=ConvertFormat(output);

TP=0;FN=0;FP=0;
Visited=zeros(1,length(output));
for i=1:length(output)
    
    if (Visited(i)==1)
        continue;
    end
    
    if (parsedoutput(i)==parsedoriginalfolding(i))       
        if (parsedoutput(i)~=0)%non-zero means pair
            
            TP=TP+1;
            
            %to avoid double counting we will break every break after
            %counting it.            
            if (parsedoutput(i)~=0)
                parsedoutput(parsedoutput(i))=0;
            end
            if (parsedoriginalfolding(i)~=0)
                parsedoriginalfolding(parsedoriginalfolding(i))=0;
            end            
            
        end
    else
        
        if (parsedoutput(i)==0)
            FN=FN+1;
            if (parsedoutput(i)~=0)
                parsedoutput(parsedoutput(i))=0;
            end
            if (parsedoriginalfolding(i)~=0)
                parsedoriginalfolding(parsedoriginalfolding(i))=0;
            end            
        else
            if (parsedoriginalfolding(i)==0)
                if (parsedoutput(i)~=0)
                    parsedoutput(parsedoutput(i))=0;
                end
                if (parsedoriginalfolding(i)~=0)
                    parsedoriginalfolding(parsedoriginalfolding(i))=0;
                end
                FP=FP+1;
            else
                FN=FN+1;
                FP=FP+1;
                if (parsedoutput(i)~=0)
                    parsedoutput(parsedoutput(i))=0;
                end
                if (parsedoriginalfolding(i)~=0)
                    parsedoriginalfolding(parsedoriginalfolding(i))=0;
                end
            end       
        end
    end            
end


Sensitivity=TP/(TP+FN);
PPV=TP/(TP+FP);
Fmeasure=Sensitivity*PPV*2/(Sensitivity+PPV);

