%BPSEQ format

%Calculates F-measure, sensitivity, positive predictive value, and true
%positives, false positives, and false negatives.
function [Fmeasure, Sensitivity, PPV, TP, FP, FN] = MeasureAccuracyArray(originalfolding, output)

%convert to BPSEQ format: --- it's already parsed in this version---
parsedoriginalfolding=originalfolding;
parsedoutput=output;

TP=0;FN=0;FP=0;

%definition 1.5
for i=1:length(output)   
    %{i,parsedoutput(i)}!=0 means that it exists
    if (parsedoutput(i)~=0) 
        %if it exists in the other structure too
        if (parsedoutput(i)==parsedoriginalfolding(i))              
            %it's a TP
            TP=TP+1;                     
        end
    end
end
%we are counting everything twice
TP=TP/2;

%definition 1.6
for i=1:length(output)
    if (parsedoriginalfolding(i)~=0)
        if (parsedoriginalfolding(i)~=parsedoutput(i))
            FN=FN+1;
        end
    end
end
FN=FN/2;

%definition 1.7
for i=1:length(output)
    if (parsedoutput(i)~=0)        
        if (parsedoriginalfolding(i)~=parsedoutput(i))        
            FP=FP+1;
        end
    end            
end
FP=FP/2;


if ((TP+FN==0) || (TP+FP==0))
    Sensitivity=0;
    PPV=0;
    Fmeasure=0;
else
    if (TP==0)
        Sensitivity=0;
        PPV=0;
        Fmeasure=0;
    else
        Sensitivity=TP/(TP+FN);
        PPV=TP/(TP+FP);
        Fmeasure=Sensitivity*PPV*2/(Sensitivity+PPV);    
    end
end