%This function is used by CMA-ES to calculate the training F-measure for a
%given set of weights and algorithms.

function [IFmeasure]=SimpleMatrixAverageFunction(w,algoinds)
%Extract the probability threshold
T=w(length(w))/10;
Threshold=T;    
%Extract the weights
w=w(1:length(w)-1);


%Algorithm Names
an={'BL*' 'CG*' 'T99' 'ContraFold' 'DIMCG' 'NOMCG' 'BL-FR*' 'MaxExpect' 'ContraFold2' 'CentroidFold'};

%Number of algorithms
na=length(an);

%Number of lines in input file (one structure per algorithm + reference structure + sequence name and ID + empty line).
nl=na+4;

%Read the trainingset
trainset='../trainingset.txt';
input=textread(trainset, '%s', 'delimiter', '\n', 'whitespace', '');

%Fmeasures will be stored here.
Fm=zeros(1,length(input)/nl);



for j=1:length(input)/nl
    %sequence
    sequence=input{(j-1)*nl+2};
    %reference structure
    originalfolding=input{(j-1)*nl+3};
    %fold the sequence (for details see AveRNA.m).
    output=MatrixAverage({input{(j-1)*nl+(algoinds)+nl-na-1}}, w);
    array=zeros(1, length(output));
    [a, b]=find(output>=Threshold/10);
    if (Threshold==0)
        [a, b]=find(output>Threshold/10);
    end
    array=GreedyMatrixToArray(output, Threshold/10);
    %arrayD=DPItrMatrixToArray(output, Threshold/10);

    %Calculate F-measure
    [f, s, p, TP, FP, FN]=MeasureAccuracyArray(ConvertFormat(originalfolding), array);
    Fm(j)=f;
end 

%1-F-measure is CMA-ES's objective function
IFmeasure=1-mean(Fm);
