%Same as SimpleMatrixAverageFunction except it works on all of the
%structures in SSTRAND2
function [IFmeasure]=SimpleMatrixAverageFunctionFull(w,algoinds)
T=w(length(w))/10;
w=w(1:length(w)-1);

trainset='../trainingset.txt';

%Algorithm Names
an={'BL*' 'CG*' 'T99' 'ContraFold' 'DIMCG' 'NOMCG' 'BL-FR*' 'MaxExpect' 'ContraFold2' 'CentroidFold'};


%Number of algorithms
na=length(an);

%Number of lines in input file (one structure per algorithm + reference structure + sequence name and ID + empty line).
nl=na+4;


input=textread(trainset, '%s', 'delimiter', '\n', 'whitespace', '');

Fm=zeros(1,length(input)/nl);


Threshold=T;    

for j=1:length(input)/nl

    sequence=input{(j-1)*nl+2};
    originalfolding=input{(j-1)*nl+3};

    output=MatrixAverage({input{(j-1)*nl+(algoinds)+nl-na-1}}, w);
    array=zeros(1, length(output));
    [a, b]=find(output>=Threshold/10);
    if (Threshold==0)
        [a, b]=find(output>Threshold/10);
    end

    array=GreedyMatrixToArray(output, Threshold/10);
%        arrayD=DPItrMatrixToArray(output, Threshold/10);

    [f, s, p, TP, FP, FN]=MeasureAccuracyArray(ConvertFormat(originalfolding), array);


    Fm(j)=f;
end        
IFmeasure=1-mean(Fm);
