/*
 * An implementation file for a class that writes a Postscript color coded
 * legend for SHAPE data.
 *
 * Copyright 2010 Mathews Lab, University of Rochester
 * Written by Jessica S. Reuter
 */

#include "Postscript_SHAPE_Legend.h"

///////////////////////////////////////////////////////////////////////////////
// Constructor
///////////////////////////////////////////////////////////////////////////////
Postscript_SHAPE_Legend::Postscript_SHAPE_Legend() : Postscript_Legend( 4 ) {}

///////////////////////////////////////////////////////////////////////////////
// Destructor
///////////////////////////////////////////////////////////////////////////////
Postscript_SHAPE_Legend::~Postscript_SHAPE_Legend() {}

///////////////////////////////////////////////////////////////////////////////
// Set the colors used in the legend.
///////////////////////////////////////////////////////////////////////////////
void Postscript_SHAPE_Legend::setColors() {

  colors[0] = RED;
  colors[1] = ORANGE;
  colors[2] = BLACK;
  colors[3] = GRAY;

}

///////////////////////////////////////////////////////////////////////////////
// Set the texts used in the legend.
///////////////////////////////////////////////////////////////////////////////
void Postscript_SHAPE_Legend::setTexts() {

  texts[0] = "0.7 >= SHAPE";
  texts[1] = "0.7 >  SHAPE >= 0.3";
  texts[2] = "0.3 >  SHAPE";
  texts[3] = "No Data";

}

