/////////////////////////////////////////////////////////////////
// Utilities.h
/////////////////////////////////////////////////////////////////

#ifndef UTILITIES_H
#define UTILITIES_H

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cerrno>
#include <cstdarg>
#include "Score.h"
#include <limits>

using namespace std;

typedef vector<Score> VF;
typedef vector<VF> VVF;
typedef vector<VVF> VVVF;
typedef vector<VVVF> VVVVF;

typedef vector<int> VI;
typedef vector<VI> VVI;
typedef vector<VVI> VVVI;
typedef vector<VVVI> VVVVI;

typedef pair<int,int> PII;
typedef vector<PII> VPII;

void Error (const char *fmt, ...);

#define _level_2_str(s) _level_1_str(s)
#define _level_1_str(s) #s
#define __LINESTR__ _level_2_str(__LINE__)
#define __FL__ "Assertion failed in file \"" __FILE__ "\", line " __LINESTR__

int _ASSERT_FAILED (const char *fmt, ...);

#ifdef NDEBUG
#define Assert(test,fmt,...)
#else
#define Assert(test,fmt,...) (test ? 0 : _ASSERT_FAILED(__FL__ ": " fmt "\n", ## __VA_ARGS__))
#endif

bool ConvertToDouble (const string &s, double &val);

string SPrintF (const char *fmt, ...);


#endif
