/////////////////////////////////////////////////////////////////
// CGOptimizationWrapper.hpp
//
// Conjugate gradient optimization algorithm.
/////////////////////////////////////////////////////////////////

#ifndef CGOPTIMIZATIONWRAPPER_HPP
#define CGOPTIMIZATIONWRAPPER_HPP

#include "Computation.hpp"
#include "OptimizationWrapper.hpp"
#include "CGLinear.hpp"

class OptimizationWrapper;

/////////////////////////////////////////////////////////////////
// class CGOptimizationWrapper
/////////////////////////////////////////////////////////////////

class CGOptimizationWrapper : public CGLinear<double>
{
    OptimizationWrapper *optimizer;
    const std::vector<int> units;
    const std::vector<double> values;
    const std::vector<double> C;
    
public:
    CGOptimizationWrapper(OptimizationWrapper *optimizer,
                          const std::vector<int> &units,
                          const std::vector<double> &values,
                          const std::vector<double> &C);
    
    void ComputeAx(std::vector<double> &Ax, const std::vector<double> &x);
    void Report(int iteration, const std::vector<double> &x, double f, double step_size);
    void Report(const std::string &s);
};

#endif
