/////////////////////////////////////////////////////////////////
// Config.hpp
/////////////////////////////////////////////////////////////////

#ifndef CONFIG_HPP
#define CONFIG_HPP

#include "Utilities.hpp"

typedef float Real;

const char DIR_SEPARATOR_CHAR = '/';
const Real HAMMING_LOSS = 0;
const std::string::size_type MAX_PATH_LENGTH = 2048;

#define COMMENT                              0

/////////////////////////////////////////////////////////////////
// Regularization type
/////////////////////////////////////////////////////////////////

#define SINGLE_HYPERPARAMETER                0
#define MULTIPLE_HYPERPARAMETERS             1
#define ARD_HYPERPARAMETERS                  0

/////////////////////////////////////////////////////////////////
// Used parameter groups
/////////////////////////////////////////////////////////////////

/*
#define PARAMS_BASE_PAIR                     1
#define PARAMS_BASE_PAIR_DIST                1
#define PARAMS_TERMINAL_MISMATCH             1
#define PARAMS_HAIRPIN_LENGTH                1
#define PARAMS_HAIRPIN_3_NUCLEOTIDES         1
#define PARAMS_HAIRPIN_4_NUCLEOTIDES         1
#define PARAMS_HELIX_LENGTH                  0
#define PARAMS_ISOLATED_BASE_PAIR            0
#define PARAMS_INTERNAL_EXPLICIT             1
#define PARAMS_BULGE_LENGTH                  1
#define PARAMS_INTERNAL_LENGTH               1
#define PARAMS_INTERNAL_SYMMETRY             1
#define PARAMS_INTERNAL_ASYMMETRY            1
#define PARAMS_BULGE_0x1_NUCLEOTIDES         1
#define PARAMS_BULGE_0x2_NUCLEOTIDES         1
#define PARAMS_BULGE_0x3_NUCLEOTIDES         1
#define PARAMS_INTERNAL_1x1_NUCLEOTIDES      1
#define PARAMS_INTERNAL_1x2_NUCLEOTIDES      1
#define PARAMS_INTERNAL_2x2_NUCLEOTIDES      1
#define PARAMS_HELIX_STACKING                1
#define PARAMS_HELIX_CLOSING                 1
#define PARAMS_MULTI_LENGTH                  1
#define PARAMS_DANGLE                        1
#define PARAMS_EXTERNAL_LENGTH               1
*/

#define PARAMS_BASE_PAIR                     1
#define PARAMS_BASE_PAIR_DIST                0
#define PARAMS_TERMINAL_MISMATCH             1
#define PARAMS_HAIRPIN_LENGTH                1
#define PARAMS_HAIRPIN_3_NUCLEOTIDES         0
#define PARAMS_HAIRPIN_4_NUCLEOTIDES         0
#define PARAMS_HELIX_LENGTH                  0
#define PARAMS_ISOLATED_BASE_PAIR            0
#define PARAMS_INTERNAL_EXPLICIT             1
#define PARAMS_BULGE_LENGTH                  1
#define PARAMS_INTERNAL_LENGTH               1
#define PARAMS_INTERNAL_SYMMETRY             1
#define PARAMS_INTERNAL_ASYMMETRY            1
#define PARAMS_BULGE_0x1_NUCLEOTIDES         1
#define PARAMS_BULGE_0x2_NUCLEOTIDES         0
#define PARAMS_BULGE_0x3_NUCLEOTIDES         0
#define PARAMS_INTERNAL_1x1_NUCLEOTIDES      1
#define PARAMS_INTERNAL_1x2_NUCLEOTIDES      0
#define PARAMS_INTERNAL_2x2_NUCLEOTIDES      0
#define PARAMS_HELIX_STACKING                1
#define PARAMS_HELIX_CLOSING                 1
#define PARAMS_MULTI_LENGTH                  1
#define PARAMS_DANGLE                        1
#define PARAMS_EXTERNAL_LENGTH               1

/*
#define PARAMS_BASE_PAIR                     1
#define PARAMS_BASE_PAIR_DIST                0
#define PARAMS_TERMINAL_MISMATCH             1
#define PARAMS_HAIRPIN_LENGTH                1
#define PARAMS_HAIRPIN_3_NUCLEOTIDES         0
#define PARAMS_HAIRPIN_4_NUCLEOTIDES         0
#define PARAMS_HELIX_LENGTH                  0
#define PARAMS_ISOLATED_BASE_PAIR            0
#define PARAMS_INTERNAL_EXPLICIT             1
#define PARAMS_BULGE_LENGTH                  1
#define PARAMS_INTERNAL_LENGTH               1
#define PARAMS_INTERNAL_SYMMETRY             1
#define PARAMS_INTERNAL_ASYMMETRY            1
#define PARAMS_BULGE_0x1_NUCLEOTIDES         1
#define PARAMS_BULGE_0x2_NUCLEOTIDES         0
#define PARAMS_BULGE_0x3_NUCLEOTIDES         0
#define PARAMS_INTERNAL_1x1_NUCLEOTIDES      1
#define PARAMS_INTERNAL_1x2_NUCLEOTIDES      0
#define PARAMS_INTERNAL_2x2_NUCLEOTIDES      0
#define PARAMS_HELIX_STACKING                1
#define PARAMS_HELIX_CLOSING                 1
#define PARAMS_MULTI_LENGTH                  1
#define PARAMS_DANGLE                        1
#define PARAMS_EXTERNAL_LENGTH               1
*/

const int C_MIN_HAIRPIN_LENGTH = 0;
const int C_MAX_SINGLE_LENGTH = 30;

const int D_MAX_HAIRPIN_LENGTH = 30;
const int D_MAX_BP_DIST_THRESHOLDS = 10;
const int D_MAX_BULGE_LENGTH = 30;
const int D_MAX_INTERNAL_LENGTH = 30;
const int D_MAX_INTERNAL_SYMMETRIC_LENGTH = 15;
const int D_MAX_INTERNAL_ASYMMETRY = 28;
const int D_MAX_INTERNAL_EXPLICIT_LENGTH = 4;
const int D_MAX_HELIX_LENGTH = 30;

const int BP_DIST_LAST_THRESHOLD = 132;
const int BP_DIST_THRESHOLDS[D_MAX_BP_DIST_THRESHOLDS] = { 3, 9, 12, 16, 21, 26, 34, 47, 71, BP_DIST_LAST_THRESHOLD };

const std::string alphabet = "ACGU";    // allowed symbols -- all other letters ignored
const int M = 4;                        // number of alphabet symbols

#endif
