/////////////////////////////////////////////////////////////////
// Parameters::GetDefaultValues()
//
// Retrieve default parameter values.
/////////////////////////////////////////////////////////////////

std::vector<double> Parameters::GetDefaultValues()
{
    std::map<std::string, double> params;

    char *default_names[714] = {
        "base_pair_AA",
        "base_pair_AC",
        "base_pair_AG",
        "base_pair_AU",
        "base_pair_CC",
        "base_pair_CG",
        "base_pair_CU",
        "base_pair_GG",
        "base_pair_GU",
        "base_pair_UU",
        "terminal_mismatch_AAAA",
        "terminal_mismatch_AAAC",
        "terminal_mismatch_AAAG",
        "terminal_mismatch_AAAU",
        "terminal_mismatch_AACA",
        "terminal_mismatch_AACC",
        "terminal_mismatch_AACG",
        "terminal_mismatch_AACU",
        "terminal_mismatch_AAGA",
        "terminal_mismatch_AAGC",
        "terminal_mismatch_AAGG",
        "terminal_mismatch_AAGU",
        "terminal_mismatch_AAUA",
        "terminal_mismatch_AAUC",
        "terminal_mismatch_AAUG",
        "terminal_mismatch_AAUU",
        "terminal_mismatch_ACAA",
        "terminal_mismatch_ACAC",
        "terminal_mismatch_ACAG",
        "terminal_mismatch_ACAU",
        "terminal_mismatch_ACCA",
        "terminal_mismatch_ACCC",
        "terminal_mismatch_ACCG",
        "terminal_mismatch_ACCU",
        "terminal_mismatch_ACGA",
        "terminal_mismatch_ACGC",
        "terminal_mismatch_ACGG",
        "terminal_mismatch_ACGU",
        "terminal_mismatch_ACUA",
        "terminal_mismatch_ACUC",
        "terminal_mismatch_ACUG",
        "terminal_mismatch_ACUU",
        "terminal_mismatch_AGAA",
        "terminal_mismatch_AGAC",
        "terminal_mismatch_AGAG",
        "terminal_mismatch_AGAU",
        "terminal_mismatch_AGCA",
        "terminal_mismatch_AGCC",
        "terminal_mismatch_AGCG",
        "terminal_mismatch_AGCU",
        "terminal_mismatch_AGGA",
        "terminal_mismatch_AGGC",
        "terminal_mismatch_AGGG",
        "terminal_mismatch_AGGU",
        "terminal_mismatch_AGUA",
        "terminal_mismatch_AGUC",
        "terminal_mismatch_AGUG",
        "terminal_mismatch_AGUU",
        "terminal_mismatch_AUAA",
        "terminal_mismatch_AUAC",
        "terminal_mismatch_AUAG",
        "terminal_mismatch_AUAU",
        "terminal_mismatch_AUCA",
        "terminal_mismatch_AUCC",
        "terminal_mismatch_AUCG",
        "terminal_mismatch_AUCU",
        "terminal_mismatch_AUGA",
        "terminal_mismatch_AUGC",
        "terminal_mismatch_AUGG",
        "terminal_mismatch_AUGU",
        "terminal_mismatch_AUUA",
        "terminal_mismatch_AUUC",
        "terminal_mismatch_AUUG",
        "terminal_mismatch_AUUU",
        "terminal_mismatch_CAAA",
        "terminal_mismatch_CAAC",
        "terminal_mismatch_CAAG",
        "terminal_mismatch_CAAU",
        "terminal_mismatch_CACA",
        "terminal_mismatch_CACC",
        "terminal_mismatch_CACG",
        "terminal_mismatch_CACU",
        "terminal_mismatch_CAGA",
        "terminal_mismatch_CAGC",
        "terminal_mismatch_CAGG",
        "terminal_mismatch_CAGU",
        "terminal_mismatch_CAUA",
        "terminal_mismatch_CAUC",
        "terminal_mismatch_CAUG",
        "terminal_mismatch_CAUU",
        "terminal_mismatch_CCAA",
        "terminal_mismatch_CCAC",
        "terminal_mismatch_CCAG",
        "terminal_mismatch_CCAU",
        "terminal_mismatch_CCCA",
        "terminal_mismatch_CCCC",
        "terminal_mismatch_CCCG",
        "terminal_mismatch_CCCU",
        "terminal_mismatch_CCGA",
        "terminal_mismatch_CCGC",
        "terminal_mismatch_CCGG",
        "terminal_mismatch_CCGU",
        "terminal_mismatch_CCUA",
        "terminal_mismatch_CCUC",
        "terminal_mismatch_CCUG",
        "terminal_mismatch_CCUU",
        "terminal_mismatch_CGAA",
        "terminal_mismatch_CGAC",
        "terminal_mismatch_CGAG",
        "terminal_mismatch_CGAU",
        "terminal_mismatch_CGCA",
        "terminal_mismatch_CGCC",
        "terminal_mismatch_CGCG",
        "terminal_mismatch_CGCU",
        "terminal_mismatch_CGGA",
        "terminal_mismatch_CGGC",
        "terminal_mismatch_CGGG",
        "terminal_mismatch_CGGU",
        "terminal_mismatch_CGUA",
        "terminal_mismatch_CGUC",
        "terminal_mismatch_CGUG",
        "terminal_mismatch_CGUU",
        "terminal_mismatch_CUAA",
        "terminal_mismatch_CUAC",
        "terminal_mismatch_CUAG",
        "terminal_mismatch_CUAU",
        "terminal_mismatch_CUCA",
        "terminal_mismatch_CUCC",
        "terminal_mismatch_CUCG",
        "terminal_mismatch_CUCU",
        "terminal_mismatch_CUGA",
        "terminal_mismatch_CUGC",
        "terminal_mismatch_CUGG",
        "terminal_mismatch_CUGU",
        "terminal_mismatch_CUUA",
        "terminal_mismatch_CUUC",
        "terminal_mismatch_CUUG",
        "terminal_mismatch_CUUU",
        "terminal_mismatch_GAAA",
        "terminal_mismatch_GAAC",
        "terminal_mismatch_GAAG",
        "terminal_mismatch_GAAU",
        "terminal_mismatch_GACA",
        "terminal_mismatch_GACC",
        "terminal_mismatch_GACG",
        "terminal_mismatch_GACU",
        "terminal_mismatch_GAGA",
        "terminal_mismatch_GAGC",
        "terminal_mismatch_GAGG",
        "terminal_mismatch_GAGU",
        "terminal_mismatch_GAUA",
        "terminal_mismatch_GAUC",
        "terminal_mismatch_GAUG",
        "terminal_mismatch_GAUU",
        "terminal_mismatch_GCAA",
        "terminal_mismatch_GCAC",
        "terminal_mismatch_GCAG",
        "terminal_mismatch_GCAU",
        "terminal_mismatch_GCCA",
        "terminal_mismatch_GCCC",
        "terminal_mismatch_GCCG",
        "terminal_mismatch_GCCU",
        "terminal_mismatch_GCGA",
        "terminal_mismatch_GCGC",
        "terminal_mismatch_GCGG",
        "terminal_mismatch_GCGU",
        "terminal_mismatch_GCUA",
        "terminal_mismatch_GCUC",
        "terminal_mismatch_GCUG",
        "terminal_mismatch_GCUU",
        "terminal_mismatch_GGAA",
        "terminal_mismatch_GGAC",
        "terminal_mismatch_GGAG",
        "terminal_mismatch_GGAU",
        "terminal_mismatch_GGCA",
        "terminal_mismatch_GGCC",
        "terminal_mismatch_GGCG",
        "terminal_mismatch_GGCU",
        "terminal_mismatch_GGGA",
        "terminal_mismatch_GGGC",
        "terminal_mismatch_GGGG",
        "terminal_mismatch_GGGU",
        "terminal_mismatch_GGUA",
        "terminal_mismatch_GGUC",
        "terminal_mismatch_GGUG",
        "terminal_mismatch_GGUU",
        "terminal_mismatch_GUAA",
        "terminal_mismatch_GUAC",
        "terminal_mismatch_GUAG",
        "terminal_mismatch_GUAU",
        "terminal_mismatch_GUCA",
        "terminal_mismatch_GUCC",
        "terminal_mismatch_GUCG",
        "terminal_mismatch_GUCU",
        "terminal_mismatch_GUGA",
        "terminal_mismatch_GUGC",
        "terminal_mismatch_GUGG",
        "terminal_mismatch_GUGU",
        "terminal_mismatch_GUUA",
        "terminal_mismatch_GUUC",
        "terminal_mismatch_GUUG",
        "terminal_mismatch_GUUU",
        "terminal_mismatch_UAAA",
        "terminal_mismatch_UAAC",
        "terminal_mismatch_UAAG",
        "terminal_mismatch_UAAU",
        "terminal_mismatch_UACA",
        "terminal_mismatch_UACC",
        "terminal_mismatch_UACG",
        "terminal_mismatch_UACU",
        "terminal_mismatch_UAGA",
        "terminal_mismatch_UAGC",
        "terminal_mismatch_UAGG",
        "terminal_mismatch_UAGU",
        "terminal_mismatch_UAUA",
        "terminal_mismatch_UAUC",
        "terminal_mismatch_UAUG",
        "terminal_mismatch_UAUU",
        "terminal_mismatch_UCAA",
        "terminal_mismatch_UCAC",
        "terminal_mismatch_UCAG",
        "terminal_mismatch_UCAU",
        "terminal_mismatch_UCCA",
        "terminal_mismatch_UCCC",
        "terminal_mismatch_UCCG",
        "terminal_mismatch_UCCU",
        "terminal_mismatch_UCGA",
        "terminal_mismatch_UCGC",
        "terminal_mismatch_UCGG",
        "terminal_mismatch_UCGU",
        "terminal_mismatch_UCUA",
        "terminal_mismatch_UCUC",
        "terminal_mismatch_UCUG",
        "terminal_mismatch_UCUU",
        "terminal_mismatch_UGAA",
        "terminal_mismatch_UGAC",
        "terminal_mismatch_UGAG",
        "terminal_mismatch_UGAU",
        "terminal_mismatch_UGCA",
        "terminal_mismatch_UGCC",
        "terminal_mismatch_UGCG",
        "terminal_mismatch_UGCU",
        "terminal_mismatch_UGGA",
        "terminal_mismatch_UGGC",
        "terminal_mismatch_UGGG",
        "terminal_mismatch_UGGU",
        "terminal_mismatch_UGUA",
        "terminal_mismatch_UGUC",
        "terminal_mismatch_UGUG",
        "terminal_mismatch_UGUU",
        "terminal_mismatch_UUAA",
        "terminal_mismatch_UUAC",
        "terminal_mismatch_UUAG",
        "terminal_mismatch_UUAU",
        "terminal_mismatch_UUCA",
        "terminal_mismatch_UUCC",
        "terminal_mismatch_UUCG",
        "terminal_mismatch_UUCU",
        "terminal_mismatch_UUGA",
        "terminal_mismatch_UUGC",
        "terminal_mismatch_UUGG",
        "terminal_mismatch_UUGU",
        "terminal_mismatch_UUUA",
        "terminal_mismatch_UUUC",
        "terminal_mismatch_UUUG",
        "terminal_mismatch_UUUU",
        "hairpin_length_at_least_0",
        "hairpin_length_at_least_1",
        "hairpin_length_at_least_2",
        "hairpin_length_at_least_3",
        "hairpin_length_at_least_4",
        "hairpin_length_at_least_5",
        "hairpin_length_at_least_6",
        "hairpin_length_at_least_7",
        "hairpin_length_at_least_8",
        "hairpin_length_at_least_9",
        "hairpin_length_at_least_10",
        "hairpin_length_at_least_11",
        "hairpin_length_at_least_12",
        "hairpin_length_at_least_13",
        "hairpin_length_at_least_14",
        "hairpin_length_at_least_15",
        "hairpin_length_at_least_16",
        "hairpin_length_at_least_17",
        "hairpin_length_at_least_18",
        "hairpin_length_at_least_19",
        "hairpin_length_at_least_20",
        "hairpin_length_at_least_21",
        "hairpin_length_at_least_22",
        "hairpin_length_at_least_23",
        "hairpin_length_at_least_24",
        "hairpin_length_at_least_25",
        "hairpin_length_at_least_26",
        "hairpin_length_at_least_27",
        "hairpin_length_at_least_28",
        "hairpin_length_at_least_29",
        "hairpin_length_at_least_30",
        "internal_explicit_1_1",
        "internal_explicit_1_2",
        "internal_explicit_1_3",
        "internal_explicit_1_4",
        "internal_explicit_2_2",
        "internal_explicit_2_3",
        "internal_explicit_2_4",
        "internal_explicit_3_3",
        "internal_explicit_3_4",
        "internal_explicit_4_4",
        "bulge_length_at_least_1",
        "bulge_length_at_least_2",
        "bulge_length_at_least_3",
        "bulge_length_at_least_4",
        "bulge_length_at_least_5",
        "bulge_length_at_least_6",
        "bulge_length_at_least_7",
        "bulge_length_at_least_8",
        "bulge_length_at_least_9",
        "bulge_length_at_least_10",
        "bulge_length_at_least_11",
        "bulge_length_at_least_12",
        "bulge_length_at_least_13",
        "bulge_length_at_least_14",
        "bulge_length_at_least_15",
        "bulge_length_at_least_16",
        "bulge_length_at_least_17",
        "bulge_length_at_least_18",
        "bulge_length_at_least_19",
        "bulge_length_at_least_20",
        "bulge_length_at_least_21",
        "bulge_length_at_least_22",
        "bulge_length_at_least_23",
        "bulge_length_at_least_24",
        "bulge_length_at_least_25",
        "bulge_length_at_least_26",
        "bulge_length_at_least_27",
        "bulge_length_at_least_28",
        "bulge_length_at_least_29",
        "bulge_length_at_least_30",
        "internal_length_at_least_2",
        "internal_length_at_least_3",
        "internal_length_at_least_4",
        "internal_length_at_least_5",
        "internal_length_at_least_6",
        "internal_length_at_least_7",
        "internal_length_at_least_8",
        "internal_length_at_least_9",
        "internal_length_at_least_10",
        "internal_length_at_least_11",
        "internal_length_at_least_12",
        "internal_length_at_least_13",
        "internal_length_at_least_14",
        "internal_length_at_least_15",
        "internal_length_at_least_16",
        "internal_length_at_least_17",
        "internal_length_at_least_18",
        "internal_length_at_least_19",
        "internal_length_at_least_20",
        "internal_length_at_least_21",
        "internal_length_at_least_22",
        "internal_length_at_least_23",
        "internal_length_at_least_24",
        "internal_length_at_least_25",
        "internal_length_at_least_26",
        "internal_length_at_least_27",
        "internal_length_at_least_28",
        "internal_length_at_least_29",
        "internal_length_at_least_30",
        "internal_symmetric_length_at_least_1",
        "internal_symmetric_length_at_least_2",
        "internal_symmetric_length_at_least_3",
        "internal_symmetric_length_at_least_4",
        "internal_symmetric_length_at_least_5",
        "internal_symmetric_length_at_least_6",
        "internal_symmetric_length_at_least_7",
        "internal_symmetric_length_at_least_8",
        "internal_symmetric_length_at_least_9",
        "internal_symmetric_length_at_least_10",
        "internal_symmetric_length_at_least_11",
        "internal_symmetric_length_at_least_12",
        "internal_symmetric_length_at_least_13",
        "internal_symmetric_length_at_least_14",
        "internal_symmetric_length_at_least_15",
        "internal_asymmetry_at_least_1",
        "internal_asymmetry_at_least_2",
        "internal_asymmetry_at_least_3",
        "internal_asymmetry_at_least_4",
        "internal_asymmetry_at_least_5",
        "internal_asymmetry_at_least_6",
        "internal_asymmetry_at_least_7",
        "internal_asymmetry_at_least_8",
        "internal_asymmetry_at_least_9",
        "internal_asymmetry_at_least_10",
        "internal_asymmetry_at_least_11",
        "internal_asymmetry_at_least_12",
        "internal_asymmetry_at_least_13",
        "internal_asymmetry_at_least_14",
        "internal_asymmetry_at_least_15",
        "internal_asymmetry_at_least_16",
        "internal_asymmetry_at_least_17",
        "internal_asymmetry_at_least_18",
        "internal_asymmetry_at_least_19",
        "internal_asymmetry_at_least_20",
        "internal_asymmetry_at_least_21",
        "internal_asymmetry_at_least_22",
        "internal_asymmetry_at_least_23",
        "internal_asymmetry_at_least_24",
        "internal_asymmetry_at_least_25",
        "internal_asymmetry_at_least_26",
        "internal_asymmetry_at_least_27",
        "internal_asymmetry_at_least_28",
        "bulge_0x1_nucleotides_A",
        "bulge_0x1_nucleotides_C",
        "bulge_0x1_nucleotides_G",
        "bulge_0x1_nucleotides_U",
        "internal_1x1_nucleotides_AA",
        "internal_1x1_nucleotides_AC",
        "internal_1x1_nucleotides_AG",
        "internal_1x1_nucleotides_AU",
        "internal_1x1_nucleotides_CA",
        "internal_1x1_nucleotides_CC",
        "internal_1x1_nucleotides_CG",
        "internal_1x1_nucleotides_CU",
        "internal_1x1_nucleotides_GA",
        "internal_1x1_nucleotides_GC",
        "internal_1x1_nucleotides_GG",
        "internal_1x1_nucleotides_GU",
        "internal_1x1_nucleotides_UA",
        "internal_1x1_nucleotides_UC",
        "internal_1x1_nucleotides_UG",
        "internal_1x1_nucleotides_UU",
        "helix_stacking_AAAA",
        "helix_stacking_AAAC",
        "helix_stacking_AAAG",
        "helix_stacking_AAAU",
        "helix_stacking_AACA",
        "helix_stacking_AACC",
        "helix_stacking_AACG",
        "helix_stacking_AACU",
        "helix_stacking_AAGA",
        "helix_stacking_AAGC",
        "helix_stacking_AAGG",
        "helix_stacking_AAGU",
        "helix_stacking_AAUA",
        "helix_stacking_AAUC",
        "helix_stacking_AAUG",
        "helix_stacking_AAUU",
        "helix_stacking_ACAC",
        "helix_stacking_ACAG",
        "helix_stacking_ACAU",
        "helix_stacking_ACCA",
        "helix_stacking_ACCC",
        "helix_stacking_ACCG",
        "helix_stacking_ACCU",
        "helix_stacking_ACGA",
        "helix_stacking_ACGC",
        "helix_stacking_ACGG",
        "helix_stacking_ACGU",
        "helix_stacking_ACUA",
        "helix_stacking_ACUC",
        "helix_stacking_ACUG",
        "helix_stacking_ACUU",
        "helix_stacking_AGAC",
        "helix_stacking_AGAG",
        "helix_stacking_AGAU",
        "helix_stacking_AGCC",
        "helix_stacking_AGCG",
        "helix_stacking_AGCU",
        "helix_stacking_AGGA",
        "helix_stacking_AGGC",
        "helix_stacking_AGGG",
        "helix_stacking_AGGU",
        "helix_stacking_AGUA",
        "helix_stacking_AGUC",
        "helix_stacking_AGUG",
        "helix_stacking_AGUU",
        "helix_stacking_AUAC",
        "helix_stacking_AUAG",
        "helix_stacking_AUAU",
        "helix_stacking_AUCC",
        "helix_stacking_AUCG",
        "helix_stacking_AUCU",
        "helix_stacking_AUGC",
        "helix_stacking_AUGG",
        "helix_stacking_AUGU",
        "helix_stacking_AUUA",
        "helix_stacking_AUUC",
        "helix_stacking_AUUG",
        "helix_stacking_AUUU",
        "helix_stacking_CAAC",
        "helix_stacking_CAAG",
        "helix_stacking_CAAU",
        "helix_stacking_CACC",
        "helix_stacking_CACG",
        "helix_stacking_CACU",
        "helix_stacking_CAGC",
        "helix_stacking_CAGG",
        "helix_stacking_CAGU",
        "helix_stacking_CAUC",
        "helix_stacking_CAUG",
        "helix_stacking_CAUU",
        "helix_stacking_CCAG",
        "helix_stacking_CCAU",
        "helix_stacking_CCCC",
        "helix_stacking_CCCG",
        "helix_stacking_CCCU",
        "helix_stacking_CCGC",
        "helix_stacking_CCGG",
        "helix_stacking_CCGU",
        "helix_stacking_CCUC",
        "helix_stacking_CCUG",
        "helix_stacking_CCUU",
        "helix_stacking_CGAG",
        "helix_stacking_CGAU",
        "helix_stacking_CGCG",
        "helix_stacking_CGCU",
        "helix_stacking_CGGC",
        "helix_stacking_CGGG",
        "helix_stacking_CGGU",
        "helix_stacking_CGUC",
        "helix_stacking_CGUG",
        "helix_stacking_CGUU",
        "helix_stacking_CUAG",
        "helix_stacking_CUAU",
        "helix_stacking_CUCG",
        "helix_stacking_CUCU",
        "helix_stacking_CUGG",
        "helix_stacking_CUGU",
        "helix_stacking_CUUC",
        "helix_stacking_CUUG",
        "helix_stacking_CUUU",
        "helix_stacking_GAAG",
        "helix_stacking_GAAU",
        "helix_stacking_GACG",
        "helix_stacking_GACU",
        "helix_stacking_GAGG",
        "helix_stacking_GAGU",
        "helix_stacking_GAUG",
        "helix_stacking_GAUU",
        "helix_stacking_GCAU",
        "helix_stacking_GCCG",
        "helix_stacking_GCCU",
        "helix_stacking_GCGG",
        "helix_stacking_GCGU",
        "helix_stacking_GCUG",
        "helix_stacking_GCUU",
        "helix_stacking_GGAU",
        "helix_stacking_GGCU",
        "helix_stacking_GGGG",
        "helix_stacking_GGGU",
        "helix_stacking_GGUG",
        "helix_stacking_GGUU",
        "helix_stacking_GUAU",
        "helix_stacking_GUCU",
        "helix_stacking_GUGU",
        "helix_stacking_GUUG",
        "helix_stacking_GUUU",
        "helix_stacking_UAAU",
        "helix_stacking_UACU",
        "helix_stacking_UAGU",
        "helix_stacking_UAUU",
        "helix_stacking_UCCU",
        "helix_stacking_UCGU",
        "helix_stacking_UCUU",
        "helix_stacking_UGGU",
        "helix_stacking_UGUU",
        "helix_stacking_UUUU",
        "helix_closing_AA",
        "helix_closing_AC",
        "helix_closing_AG",
        "helix_closing_AU",
        "helix_closing_CA",
        "helix_closing_CC",
        "helix_closing_CG",
        "helix_closing_CU",
        "helix_closing_GA",
        "helix_closing_GC",
        "helix_closing_GG",
        "helix_closing_GU",
        "helix_closing_UA",
        "helix_closing_UC",
        "helix_closing_UG",
        "helix_closing_UU",
        "multi_base",
        "multi_unpaired",
        "multi_paired",
        "dangle_left_AAA",
        "dangle_left_AAC",
        "dangle_left_AAG",
        "dangle_left_AAU",
        "dangle_left_ACA",
        "dangle_left_ACC",
        "dangle_left_ACG",
        "dangle_left_ACU",
        "dangle_left_AGA",
        "dangle_left_AGC",
        "dangle_left_AGG",
        "dangle_left_AGU",
        "dangle_left_AUA",
        "dangle_left_AUC",
        "dangle_left_AUG",
        "dangle_left_AUU",
        "dangle_left_CAA",
        "dangle_left_CAC",
        "dangle_left_CAG",
        "dangle_left_CAU",
        "dangle_left_CCA",
        "dangle_left_CCC",
        "dangle_left_CCG",
        "dangle_left_CCU",
        "dangle_left_CGA",
        "dangle_left_CGC",
        "dangle_left_CGG",
        "dangle_left_CGU",
        "dangle_left_CUA",
        "dangle_left_CUC",
        "dangle_left_CUG",
        "dangle_left_CUU",
        "dangle_left_GAA",
        "dangle_left_GAC",
        "dangle_left_GAG",
        "dangle_left_GAU",
        "dangle_left_GCA",
        "dangle_left_GCC",
        "dangle_left_GCG",
        "dangle_left_GCU",
        "dangle_left_GGA",
        "dangle_left_GGC",
        "dangle_left_GGG",
        "dangle_left_GGU",
        "dangle_left_GUA",
        "dangle_left_GUC",
        "dangle_left_GUG",
        "dangle_left_GUU",
        "dangle_left_UAA",
        "dangle_left_UAC",
        "dangle_left_UAG",
        "dangle_left_UAU",
        "dangle_left_UCA",
        "dangle_left_UCC",
        "dangle_left_UCG",
        "dangle_left_UCU",
        "dangle_left_UGA",
        "dangle_left_UGC",
        "dangle_left_UGG",
        "dangle_left_UGU",
        "dangle_left_UUA",
        "dangle_left_UUC",
        "dangle_left_UUG",
        "dangle_left_UUU",
        "dangle_right_AAA",
        "dangle_right_AAC",
        "dangle_right_AAG",
        "dangle_right_AAU",
        "dangle_right_ACA",
        "dangle_right_ACC",
        "dangle_right_ACG",
        "dangle_right_ACU",
        "dangle_right_AGA",
        "dangle_right_AGC",
        "dangle_right_AGG",
        "dangle_right_AGU",
        "dangle_right_AUA",
        "dangle_right_AUC",
        "dangle_right_AUG",
        "dangle_right_AUU",
        "dangle_right_CAA",
        "dangle_right_CAC",
        "dangle_right_CAG",
        "dangle_right_CAU",
        "dangle_right_CCA",
        "dangle_right_CCC",
        "dangle_right_CCG",
        "dangle_right_CCU",
        "dangle_right_CGA",
        "dangle_right_CGC",
        "dangle_right_CGG",
        "dangle_right_CGU",
        "dangle_right_CUA",
        "dangle_right_CUC",
        "dangle_right_CUG",
        "dangle_right_CUU",
        "dangle_right_GAA",
        "dangle_right_GAC",
        "dangle_right_GAG",
        "dangle_right_GAU",
        "dangle_right_GCA",
        "dangle_right_GCC",
        "dangle_right_GCG",
        "dangle_right_GCU",
        "dangle_right_GGA",
        "dangle_right_GGC",
        "dangle_right_GGG",
        "dangle_right_GGU",
        "dangle_right_GUA",
        "dangle_right_GUC",
        "dangle_right_GUG",
        "dangle_right_GUU",
        "dangle_right_UAA",
        "dangle_right_UAC",
        "dangle_right_UAG",
        "dangle_right_UAU",
        "dangle_right_UCA",
        "dangle_right_UCC",
        "dangle_right_UCG",
        "dangle_right_UCU",
        "dangle_right_UGA",
        "dangle_right_UGC",
        "dangle_right_UGG",
        "dangle_right_UGU",
        "dangle_right_UUA",
        "dangle_right_UUC",
        "dangle_right_UUG",
        "dangle_right_UUU",
        "external_unpaired",
        "external_paired"
    };

    double default_values[714] =
    {
        -0.4979095334,
        -0.6745156055,
        -0.7652147404,
        0.2994608738,
        -0.2824894433,
        0.7949970674,
        -0.5802439231,
        -0.355807926,
        0.09669584845,
        -0.361702827,
        -0.3664089259,
        -0.1724941645,
        -0.3316017271,
        -0.2180077876,
        -0.216251315,
        -0.09189573052,
        -0.1298712741,
        -0.1001192475,
        -0.2436223832,
        -0.1013031976,
        -0.2155165679,
        -0.1333726322,
        -0.1381912179,
        -0.06066474176,
        -0.09836714362,
        -0.1026952646,
        -0.2796564476,
        -0.1843841186,
        -0.2426543557,
        -0.1265753115,
        -0.1095977701,
        -0.08246411619,
        -0.07199304327,
        -0.09910368188,
        -0.1368896593,
        -0.07962050063,
        -0.1399490713,
        -0.09354324175,
        -0.09026640345,
        -0.08073523977,
        -0.08587973103,
        -0.07571192895,
        -0.2680806608,
        -0.1787284808,
        -0.2637112894,
        -0.1430741733,
        -0.09123383147,
        -0.05826244662,
        -0.09647839199,
        -0.07659616572,
        -0.136824554,
        -0.1173113088,
        -0.2415011607,
        -0.1039031854,
        -0.09540315592,
        -0.07718264955,
        -0.1154209277,
        -0.1114245309,
        0.1413631889,
        -0.1416244361,
        -0.5243684683,
        -0.4488154312,
        0.0743456478,
        0.222638244,
        -0.1114277803,
        -0.00874369413,
        0.6613558924,
        -0.2664722559,
        -0.3617059561,
        -0.7570487229,
        0.4144366005,
        0.4031363812,
        0.1415049987,
        0.6949176846,
        -0.2269669636,
        -0.1743864972,
        -0.1534907404,
        -0.1046678086,
        -0.2249249593,
        -0.09574709334,
        -0.1355567174,
        -0.1056929972,
        -0.157499716,
        -0.06824708836,
        -0.08338089429,
        -0.07387105439,
        -0.1740575132,
        -0.06695062154,
        -0.08309468402,
        -0.07120122451,
        -0.2180037174,
        -0.1653052267,
        -0.1579845048,
        -0.1044982909,
        -0.1431339089,
        -0.1440322855,
        -0.05689050311,
        -0.111512024,
        -0.1188358169,
        -0.08995369737,
        -0.08273121803,
        -0.07944731103,
        -0.0975275365,
        -0.05872669766,
        -0.05904230282,
        -0.09874358231,
        0.3668346388,
        -0.1516517676,
        -0.58727129,
        -0.07239322437,
        0.2141878329,
        0.05352983116,
        0.006333325186,
        -0.5627301216,
        1.014324828,
        -0.5404583326,
        -0.4413747265,
        -0.5833452024,
        0.3593014272,
        0.1833494023,
        -0.09601572496,
        0.09869751818,
        -0.1460705987,
        -0.08452285947,
        -0.1513680516,
        -0.08888521326,
        -0.1318337409,
        -0.06911109204,
        -0.0900147029,
        -0.1528093683,
        -0.09063368313,
        -0.06206515389,
        -0.1002405442,
        -0.07702623914,
        -0.1071166791,
        -0.04877766125,
        -0.1132278818,
        -0.1139597112,
        -0.2845228739,
        -0.1087836806,
        -0.310273511,
        -0.1887178279,
        -0.1425300407,
        -0.05991601338,
        -0.07218676318,
        -0.06430472854,
        -0.1595852785,
        -0.07249026061,
        -0.1239959169,
        -0.1067468818,
        -0.1434606025,
        -0.08615582926,
        -0.09315128603,
        -0.07989943899,
        0.05166591925,
        0.2487876241,
        -0.2248832682,
        -0.7771882613,
        0.111072048,
        -0.1924816964,
        0.1920087152,
        -0.1588056663,
        0.6848732975,
        -0.7483632908,
        0.4073409047,
        -0.4364601497,
        0.09353684593,
        0.4931904887,
        -0.1931840804,
        0.7079361939,
        -0.2112387686,
        -0.1426614491,
        -0.2320129186,
        -0.1476841351,
        -0.1348958415,
        -0.06452116075,
        -0.08377281371,
        -0.08550541158,
        -0.2307073651,
        -0.07825721485,
        -0.1134844051,
        -0.09867051753,
        -0.1810421439,
        -0.09319924532,
        -0.09073596826,
        -0.09578954076,
        0.01470372434,
        0.08188097761,
        0.560156949,
        -0.4108016482,
        0.4098870577,
        -0.2354505577,
        -0.113419162,
        0.1695438024,
        0.5760956993,
        -0.01729766431,
        -0.003147665531,
        0.2458997581,
        -0.03028739751,
        -0.2464466829,
        -0.4282999067,
        -0.04762337213,
        0.4074657897,
        -0.1797432016,
        0.3631970952,
        -0.1891968833,
        -0.2179185207,
        -0.6048136251,
        0.2145347861,
        -0.1731768392,
        0.765170845,
        -0.08179987299,
        -0.05348335729,
        -0.6154518465,
        -0.1650113199,
        0.5590985677,
        -0.2961393377,
        0.3526107942,
        -0.1722416934,
        -0.1263144827,
        -0.1473778712,
        -0.09394553131,
        -0.1718234564,
        -0.07494873423,
        -0.05852164594,
        -0.2567601009,
        -0.1155035816,
        -0.08183904281,
        -0.07374083102,
        -0.1010416297,
        -0.08923046488,
        -0.0813727834,
        -0.06862245224,
        -0.135625829,
        0.643739219,
        0.4636912287,
        -0.1192285903,
        0.6425496574,
        -0.3388220138,
        -0.03878621548,
        0.2556180185,
        -0.3004286958,
        1.015397618,
        0.1618797567,
        0.3466628965,
        -0.2869582101,
        -0.03570362246,
        0.09058715876,
        0.337800875,
        0.06114283909,
        -0.2001704124,
        -0.0817799572,
        -0.1416177972,
        -0.1098465199,
        -0.09657761272,
        -0.07449230672,
        -0.09391358489,
        -0.1358658366,
        -0.2455547898,
        -0.08215136571,
        -0.1056909493,
        -0.1471455739,
        -0.1519942426,
        -0.1091794505,
        -0.134951348,
        -0.2644676508,
        -8.53455415,
        -2.772814369,
        0.878686669,
        3.366045913,
        2.82444084,
        -0.4114961932,
        0.1208542394,
        1.159206655,
        -0.7614673264,
        -0.01622220754,
        0.07275921886,
        0.2521448707,
        -0.6890863781,
        -0.1051662792,
        -0.3157380786,
        0.1499239087,
        0.5453233869,
        0.7121221005,
        0.130986237,
        -0.02760761491,
        -0.1698125103,
        -0.04703354843,
        0.02236182494,
        0.03193561602,
        0.07917168236,
        0.05414619702,
        0.07479150593,
        0.03255929134,
        0.04079873166,
        0.04574505544,
        -0.006480709799,
        -0.1207332937,
        0.04599351564,
        -0.1011224583,
        -0.2539402243,
        0.05079921143,
        -0.2471468872,
        0.2363068694,
        -0.005151542021,
        0.2082191286,
        -0.09381159731,
        -3.510048669,
        -0.7451570223,
        -0.7319543068,
        -0.7449369868,
        -0.2205721568,
        0.2597657106,
        0.4660466887,
        0.9674751528,
        -0.3372532002,
        -0.4778521069,
        -0.2113801527,
        -0.08950559249,
        -0.0410646359,
        0.001076645048,
        0.02615939458,
        0.04366384122,
        0.05665990018,
        0.06668316737,
        0.07107929368,
        0.02641851434,
        0.02801890013,
        -0.00245042647,
        -0.001381322784,
        -0.00085501319,
        -0.0006297897362,
        -0.0002646571386,
        -0.0001900842713,
        -0.0001372527298,
        -5.562478293e-05,
        -6.834098264e-06,
        -0.08147614054,
        -0.01524114612,
        -0.03195071359,
        0.0026592996,
        0.2321593423,
        0.201978555,
        0.1190329436,
        0.2845556793,
        0.06354609115,
        0.1039455502,
        0.0001911098974,
        0.001943833213,
        0.1988970296,
        0.09771044741,
        0.1534825998,
        0.1284833991,
        0.1786662284,
        0.1994457926,
        0.183700723,
        0.09720128296,
        0.02422153049,
        0.01467001902,
        0.0230728101,
        0.01919041165,
        0.02601180283,
        0.0228783273,
        0.0258340463,
        0.02015537689,
        0.01045791892,
        -2.447704117,
        -0.4345170902,
        -0.8102909164,
        -0.1714281602,
        1.102903814,
        -1.303532289,
        -0.2853384145,
        0.594889746,
        -0.3989232809,
        -0.1060364067,
        -0.0188628867,
        -0.08470345337,
        -0.02577760463,
        -0.007858347272,
        -0.002449192486,
        -3.815922998,
        -0.7265348699,
        -0.601573673,
        -0.8156140956,
        -0.5340051438,
        -0.2778745565,
        0.2187239516,
        0.0005612871731,
        -0.2785531767,
        0.1815280295,
        -0.2563754979,
        -0.1300780807,
        0.04059389041,
        -0.002880420548,
        -0.02189608468,
        -0.06277166224,
        -0.0459237034,
        -0.05757816547,
        -0.03140743759,
        -0.01970189914,
        -0.01158593303,
        -0.008556034576,
        -0.005700499432,
        -0.00355007755,
        -0.002530319153,
        -0.0006778960983,
        -0.0001431376054,
        -5.244028303e-05,
        -0.7077593948,
        -0.636687753,
        -0.343161699,
        -0.4408620453,
        0.1205333625,
        -0.04944153208,
        -0.1504212591,
        -0.0598169344,
        -0.0231573306,
        -0.03697548359,
        0.04066835841,
        0.03637580014,
        0.07148331026,
        0.01756383335,
        -0.02507952465,
        -0.04800567596,
        -0.02581344812,
        0.03012842529,
        -0.05001372041,
        0.1256216049,
        -0.1524979765,
        -0.1247485473,
        -0.1813288727,
        -0.7898882011,
        -0.158785601,
        -0.1187595159,
        -0.8753838163,
        -0.07967651704,
        -0.1505376112,
        -0.7679799363,
        -0.1161062042,
        -0.3154784033,
        -0.6783897627,
        -0.05466178844,
        -0.3841335299,
        -0.09454877431,
        -0.1122480019,
        -0.09314566857,
        -0.4598674963,
        -0.02910861912,
        -0.05662760667,
        -0.6349301394,
        -0.07551120405,
        -0.05673507637,
        -0.599518489,
        -0.09399158998,
        -0.2500236115,
        -0.4382884683,
        -0.05182286845,
        -0.3095114348,
        -0.04689379965,
        -0.0732579598,
        -0.11420279,
        -0.5763973835,
        -0.04712227368,
        -0.6973125888,
        -0.04483497517,
        -0.03070101089,
        -0.6622557524,
        -0.149399968,
        -0.3416932874,
        -0.4939721191,
        -0.04057039333,
        -0.3340103587,
        -0.06316007822,
        -0.5569881019,
        -0.5986089084,
        0.7890829212,
        -0.3880069659,
        1.417522268,
        -0.3587642055,
        1.758294581,
        -0.5364245812,
        0.1894591059,
        0.9404399642,
        -0.5386725969,
        0.7767456311,
        -0.5136273904,
        -0.06969839661,
        -0.05910577152,
        -0.4004730625,
        -0.05852384038,
        -0.7500932336,
        -0.04796211668,
        -0.5673244183,
        -0.05566507661,
        -0.2191128838,
        -0.04433246244,
        -0.2524782578,
        -0.04260065948,
        -0.05644902113,
        -0.4212816007,
        -0.02519231481,
        -0.567994127,
        -0.04579766629,
        -0.5638767852,
        -0.04929115014,
        -0.2281349531,
        -0.03341822962,
        -0.204655498,
        -0.05767106085,
        -0.6376564047,
        1.506186744,
        2.094054915,
        -0.5173082673,
        1.5313865,
        -0.6226595898,
        0.4058107712,
        -0.4961277394,
        1.22037782,
        -0.6418092431,
        -0.05473960515,
        -0.4227773301,
        -0.6044700147,
        -0.08937170081,
        -0.06057088627,
        -0.2307328801,
        -0.01046166746,
        -0.2512616101,
        -0.06608816699,
        -0.08802186032,
        -0.557677641,
        -0.6619891813,
        -0.04397576565,
        -0.09511011171,
        -0.2773757055,
        -0.2868777717,
        -0.05732441771,
        1.600130195,
        1.83349352,
        -0.5765768544,
        -0.676088554,
        0.9265083418,
        1.283460783,
        -0.6636656612,
        -0.4856910649,
        -0.04887718452,
        -0.03924332586,
        -0.2859166354,
        -0.2667923372,
        -0.07100306905,
        0.4627055129,
        -0.2028523672,
        0.3755200524,
        -0.3484054957,
        -0.304457216,
        1.154764402,
        -0.3895556624,
        -0.004353595823,
        -0.5057638676,
        -0.1028586858,
        -0.2031442584,
        -0.06937340946,
        0.3596209116,
        -0.3556767461,
        -0.09488914869,
        -0.9707179635,
        -0.710098803,
        -0.7944351256,
        0.2256046048,
        -0.7057052456,
        -0.6387748894,
        0.9836481346,
        -0.5724957217,
        -0.7569138954,
        0.7312006503,
        -0.7617094162,
        -0.1091081429,
        0.3164946451,
        -0.6252803333,
        0.6854225896,
        -0.7537349985,
        -1.108130665,
        0.03357118025,
        -1.615303075,
        -0.01573490927,
        -0.009936651978,
        -0.01219234858,
        -0.008927064912,
        -0.01221153328,
        -0.006663737334,
        -0.0112034811,
        -0.005033948631,
        -0.01293380224,
        -0.009436021128,
        -0.01281987589,
        -0.006153837196,
        -0.09895603119,
        -0.004390698368,
        0.05426025408,
        0.0392780358,
        -0.009720865764,
        -0.00765610646,
        -0.008720566703,
        -0.007773188948,
        -0.01116180338,
        -0.005351462747,
        -0.008670472568,
        -0.006780295219,
        0.05152011607,
        0.03980196759,
        0.1508599097,
        -0.08621818316,
        -0.009805223608,
        -0.005313699484,
        -0.006685459095,
        -0.005465897155,
        -0.01230594634,
        -0.01042573379,
        -0.01047289614,
        -0.007422010347,
        -0.1057592936,
        0.1137327351,
        0.1269327227,
        -0.1072103772,
        -0.01259352743,
        -0.01088361962,
        -0.01108434821,
        -0.008437252704,
        -0.02234368799,
        0.006637930645,
        -0.02430294339,
        -0.01933795307,
        -0.04012301127,
        0.00946117145,
        -0.04177357651,
        0.0297713475,
        -0.009630646284,
        -0.004174269365,
        -0.007951924428,
        -0.004681591381,
        -0.1160805809,
        0.01617213047,
        0.1293682864,
        -0.06457791281,
        -0.01014913458,
        -0.005644924871,
        -0.0100301712,
        -0.00911270958,
        -0.01436595106,
        -0.01062538406,
        -0.01580944261,
        -0.009012112216,
        -0.009581923954,
        -0.009178008382,
        -0.009285696305,
        -0.00634635203,
        -0.009848632809,
        -0.0110682695,
        -0.01142015627,
        -0.008280561401,
        0.04259506687,
        -0.02604839738,
        -0.06193753998,
        -0.01377319484,
        -0.01087224436,
        -0.009312487034,
        -0.008005050249,
        -0.005752954475,
        -0.00691696667,
        -0.007986556726,
        -0.007111687412,
        -0.009381149309,
        0.2795530884,
        -0.05258072582,
        -0.0239479951,
        -0.1402715709,
        -0.006580034209,
        -0.005092220502,
        -0.009932032576,
        -0.00518588126,
        -0.01302641541,
        -0.008475771613,
        -0.01000367763,
        -0.009139774275,
        0.0834983399,
        0.05346661731,
        0.03645729311,
        -0.1731063531,
        -0.01154494891,
        -0.01054856452,
        -0.009972252305,
        -0.00959126684,
        -0.02457774911,
        -0.0179100478,
        -0.03428511124,
        -0.006434746471,
        -0.04055298916,
        0.07497605686,
        -0.1104340703,
        -0.01620765403,
        -0.006845050988,
        -0.006872555297,
        -0.00659352161,
        -0.005411104198,
        0.03092950428,
        0.002465833038,
        -0.03398495312,
        -0.0281363635,
        -0.01077510242,
        -0.006376059887,
        -0.009915754329,
        -0.00805379221,
        0.008598116298,
        0.0001690186265
    };

    for (size_t i = 0; i < 714; i++)
        params[default_names[i]] = default_values[i];

    std::vector<double> values(names.size());
    for (size_t i = 0; i < names.size(); i++)
    {
        std::map<std::string, double>::iterator iter = params.find(names[i]);
        if (iter == params.end())
            Error("Default parameter file missing parameter: %s", names[i].c_str());
        values[i] = iter->second;
        params.erase(iter);
    }

    for (std::map<std::string, double>::iterator iter = params.begin(); iter != params.end(); ++iter)
        Warning("Default parameter file contains extra parameter: %s", iter->first.c_str());

    return values;
}

/////////////////////////////////////////////////////////////////
// Parameters::GetDefaultComplementaryValues()
//
// Retrieve default parameter values.
/////////////////////////////////////////////////////////////////

std::vector<double> Parameters::GetDefaultComplementaryValues()
{
    std::map<std::string, double> params;

    char *default_names[714] = {
        "base_pair_AA",
        "base_pair_AC",
        "base_pair_AG",
        "base_pair_AU",
        "base_pair_CC",
        "base_pair_CG",
        "base_pair_CU",
        "base_pair_GG",
        "base_pair_GU",
        "base_pair_UU",
        "terminal_mismatch_AAAA",
        "terminal_mismatch_AAAC",
        "terminal_mismatch_AAAG",
        "terminal_mismatch_AAAU",
        "terminal_mismatch_AACA",
        "terminal_mismatch_AACC",
        "terminal_mismatch_AACG",
        "terminal_mismatch_AACU",
        "terminal_mismatch_AAGA",
        "terminal_mismatch_AAGC",
        "terminal_mismatch_AAGG",
        "terminal_mismatch_AAGU",
        "terminal_mismatch_AAUA",
        "terminal_mismatch_AAUC",
        "terminal_mismatch_AAUG",
        "terminal_mismatch_AAUU",
        "terminal_mismatch_ACAA",
        "terminal_mismatch_ACAC",
        "terminal_mismatch_ACAG",
        "terminal_mismatch_ACAU",
        "terminal_mismatch_ACCA",
        "terminal_mismatch_ACCC",
        "terminal_mismatch_ACCG",
        "terminal_mismatch_ACCU",
        "terminal_mismatch_ACGA",
        "terminal_mismatch_ACGC",
        "terminal_mismatch_ACGG",
        "terminal_mismatch_ACGU",
        "terminal_mismatch_ACUA",
        "terminal_mismatch_ACUC",
        "terminal_mismatch_ACUG",
        "terminal_mismatch_ACUU",
        "terminal_mismatch_AGAA",
        "terminal_mismatch_AGAC",
        "terminal_mismatch_AGAG",
        "terminal_mismatch_AGAU",
        "terminal_mismatch_AGCA",
        "terminal_mismatch_AGCC",
        "terminal_mismatch_AGCG",
        "terminal_mismatch_AGCU",
        "terminal_mismatch_AGGA",
        "terminal_mismatch_AGGC",
        "terminal_mismatch_AGGG",
        "terminal_mismatch_AGGU",
        "terminal_mismatch_AGUA",
        "terminal_mismatch_AGUC",
        "terminal_mismatch_AGUG",
        "terminal_mismatch_AGUU",
        "terminal_mismatch_AUAA",
        "terminal_mismatch_AUAC",
        "terminal_mismatch_AUAG",
        "terminal_mismatch_AUAU",
        "terminal_mismatch_AUCA",
        "terminal_mismatch_AUCC",
        "terminal_mismatch_AUCG",
        "terminal_mismatch_AUCU",
        "terminal_mismatch_AUGA",
        "terminal_mismatch_AUGC",
        "terminal_mismatch_AUGG",
        "terminal_mismatch_AUGU",
        "terminal_mismatch_AUUA",
        "terminal_mismatch_AUUC",
        "terminal_mismatch_AUUG",
        "terminal_mismatch_AUUU",
        "terminal_mismatch_CAAA",
        "terminal_mismatch_CAAC",
        "terminal_mismatch_CAAG",
        "terminal_mismatch_CAAU",
        "terminal_mismatch_CACA",
        "terminal_mismatch_CACC",
        "terminal_mismatch_CACG",
        "terminal_mismatch_CACU",
        "terminal_mismatch_CAGA",
        "terminal_mismatch_CAGC",
        "terminal_mismatch_CAGG",
        "terminal_mismatch_CAGU",
        "terminal_mismatch_CAUA",
        "terminal_mismatch_CAUC",
        "terminal_mismatch_CAUG",
        "terminal_mismatch_CAUU",
        "terminal_mismatch_CCAA",
        "terminal_mismatch_CCAC",
        "terminal_mismatch_CCAG",
        "terminal_mismatch_CCAU",
        "terminal_mismatch_CCCA",
        "terminal_mismatch_CCCC",
        "terminal_mismatch_CCCG",
        "terminal_mismatch_CCCU",
        "terminal_mismatch_CCGA",
        "terminal_mismatch_CCGC",
        "terminal_mismatch_CCGG",
        "terminal_mismatch_CCGU",
        "terminal_mismatch_CCUA",
        "terminal_mismatch_CCUC",
        "terminal_mismatch_CCUG",
        "terminal_mismatch_CCUU",
        "terminal_mismatch_CGAA",
        "terminal_mismatch_CGAC",
        "terminal_mismatch_CGAG",
        "terminal_mismatch_CGAU",
        "terminal_mismatch_CGCA",
        "terminal_mismatch_CGCC",
        "terminal_mismatch_CGCG",
        "terminal_mismatch_CGCU",
        "terminal_mismatch_CGGA",
        "terminal_mismatch_CGGC",
        "terminal_mismatch_CGGG",
        "terminal_mismatch_CGGU",
        "terminal_mismatch_CGUA",
        "terminal_mismatch_CGUC",
        "terminal_mismatch_CGUG",
        "terminal_mismatch_CGUU",
        "terminal_mismatch_CUAA",
        "terminal_mismatch_CUAC",
        "terminal_mismatch_CUAG",
        "terminal_mismatch_CUAU",
        "terminal_mismatch_CUCA",
        "terminal_mismatch_CUCC",
        "terminal_mismatch_CUCG",
        "terminal_mismatch_CUCU",
        "terminal_mismatch_CUGA",
        "terminal_mismatch_CUGC",
        "terminal_mismatch_CUGG",
        "terminal_mismatch_CUGU",
        "terminal_mismatch_CUUA",
        "terminal_mismatch_CUUC",
        "terminal_mismatch_CUUG",
        "terminal_mismatch_CUUU",
        "terminal_mismatch_GAAA",
        "terminal_mismatch_GAAC",
        "terminal_mismatch_GAAG",
        "terminal_mismatch_GAAU",
        "terminal_mismatch_GACA",
        "terminal_mismatch_GACC",
        "terminal_mismatch_GACG",
        "terminal_mismatch_GACU",
        "terminal_mismatch_GAGA",
        "terminal_mismatch_GAGC",
        "terminal_mismatch_GAGG",
        "terminal_mismatch_GAGU",
        "terminal_mismatch_GAUA",
        "terminal_mismatch_GAUC",
        "terminal_mismatch_GAUG",
        "terminal_mismatch_GAUU",
        "terminal_mismatch_GCAA",
        "terminal_mismatch_GCAC",
        "terminal_mismatch_GCAG",
        "terminal_mismatch_GCAU",
        "terminal_mismatch_GCCA",
        "terminal_mismatch_GCCC",
        "terminal_mismatch_GCCG",
        "terminal_mismatch_GCCU",
        "terminal_mismatch_GCGA",
        "terminal_mismatch_GCGC",
        "terminal_mismatch_GCGG",
        "terminal_mismatch_GCGU",
        "terminal_mismatch_GCUA",
        "terminal_mismatch_GCUC",
        "terminal_mismatch_GCUG",
        "terminal_mismatch_GCUU",
        "terminal_mismatch_GGAA",
        "terminal_mismatch_GGAC",
        "terminal_mismatch_GGAG",
        "terminal_mismatch_GGAU",
        "terminal_mismatch_GGCA",
        "terminal_mismatch_GGCC",
        "terminal_mismatch_GGCG",
        "terminal_mismatch_GGCU",
        "terminal_mismatch_GGGA",
        "terminal_mismatch_GGGC",
        "terminal_mismatch_GGGG",
        "terminal_mismatch_GGGU",
        "terminal_mismatch_GGUA",
        "terminal_mismatch_GGUC",
        "terminal_mismatch_GGUG",
        "terminal_mismatch_GGUU",
        "terminal_mismatch_GUAA",
        "terminal_mismatch_GUAC",
        "terminal_mismatch_GUAG",
        "terminal_mismatch_GUAU",
        "terminal_mismatch_GUCA",
        "terminal_mismatch_GUCC",
        "terminal_mismatch_GUCG",
        "terminal_mismatch_GUCU",
        "terminal_mismatch_GUGA",
        "terminal_mismatch_GUGC",
        "terminal_mismatch_GUGG",
        "terminal_mismatch_GUGU",
        "terminal_mismatch_GUUA",
        "terminal_mismatch_GUUC",
        "terminal_mismatch_GUUG",
        "terminal_mismatch_GUUU",
        "terminal_mismatch_UAAA",
        "terminal_mismatch_UAAC",
        "terminal_mismatch_UAAG",
        "terminal_mismatch_UAAU",
        "terminal_mismatch_UACA",
        "terminal_mismatch_UACC",
        "terminal_mismatch_UACG",
        "terminal_mismatch_UACU",
        "terminal_mismatch_UAGA",
        "terminal_mismatch_UAGC",
        "terminal_mismatch_UAGG",
        "terminal_mismatch_UAGU",
        "terminal_mismatch_UAUA",
        "terminal_mismatch_UAUC",
        "terminal_mismatch_UAUG",
        "terminal_mismatch_UAUU",
        "terminal_mismatch_UCAA",
        "terminal_mismatch_UCAC",
        "terminal_mismatch_UCAG",
        "terminal_mismatch_UCAU",
        "terminal_mismatch_UCCA",
        "terminal_mismatch_UCCC",
        "terminal_mismatch_UCCG",
        "terminal_mismatch_UCCU",
        "terminal_mismatch_UCGA",
        "terminal_mismatch_UCGC",
        "terminal_mismatch_UCGG",
        "terminal_mismatch_UCGU",
        "terminal_mismatch_UCUA",
        "terminal_mismatch_UCUC",
        "terminal_mismatch_UCUG",
        "terminal_mismatch_UCUU",
        "terminal_mismatch_UGAA",
        "terminal_mismatch_UGAC",
        "terminal_mismatch_UGAG",
        "terminal_mismatch_UGAU",
        "terminal_mismatch_UGCA",
        "terminal_mismatch_UGCC",
        "terminal_mismatch_UGCG",
        "terminal_mismatch_UGCU",
        "terminal_mismatch_UGGA",
        "terminal_mismatch_UGGC",
        "terminal_mismatch_UGGG",
        "terminal_mismatch_UGGU",
        "terminal_mismatch_UGUA",
        "terminal_mismatch_UGUC",
        "terminal_mismatch_UGUG",
        "terminal_mismatch_UGUU",
        "terminal_mismatch_UUAA",
        "terminal_mismatch_UUAC",
        "terminal_mismatch_UUAG",
        "terminal_mismatch_UUAU",
        "terminal_mismatch_UUCA",
        "terminal_mismatch_UUCC",
        "terminal_mismatch_UUCG",
        "terminal_mismatch_UUCU",
        "terminal_mismatch_UUGA",
        "terminal_mismatch_UUGC",
        "terminal_mismatch_UUGG",
        "terminal_mismatch_UUGU",
        "terminal_mismatch_UUUA",
        "terminal_mismatch_UUUC",
        "terminal_mismatch_UUUG",
        "terminal_mismatch_UUUU",
        "hairpin_length_at_least_0",
        "hairpin_length_at_least_1",
        "hairpin_length_at_least_2",
        "hairpin_length_at_least_3",
        "hairpin_length_at_least_4",
        "hairpin_length_at_least_5",
        "hairpin_length_at_least_6",
        "hairpin_length_at_least_7",
        "hairpin_length_at_least_8",
        "hairpin_length_at_least_9",
        "hairpin_length_at_least_10",
        "hairpin_length_at_least_11",
        "hairpin_length_at_least_12",
        "hairpin_length_at_least_13",
        "hairpin_length_at_least_14",
        "hairpin_length_at_least_15",
        "hairpin_length_at_least_16",
        "hairpin_length_at_least_17",
        "hairpin_length_at_least_18",
        "hairpin_length_at_least_19",
        "hairpin_length_at_least_20",
        "hairpin_length_at_least_21",
        "hairpin_length_at_least_22",
        "hairpin_length_at_least_23",
        "hairpin_length_at_least_24",
        "hairpin_length_at_least_25",
        "hairpin_length_at_least_26",
        "hairpin_length_at_least_27",
        "hairpin_length_at_least_28",
        "hairpin_length_at_least_29",
        "hairpin_length_at_least_30",
        "internal_explicit_1_1",
        "internal_explicit_1_2",
        "internal_explicit_1_3",
        "internal_explicit_1_4",
        "internal_explicit_2_2",
        "internal_explicit_2_3",
        "internal_explicit_2_4",
        "internal_explicit_3_3",
        "internal_explicit_3_4",
        "internal_explicit_4_4",
        "bulge_length_at_least_1",
        "bulge_length_at_least_2",
        "bulge_length_at_least_3",
        "bulge_length_at_least_4",
        "bulge_length_at_least_5",
        "bulge_length_at_least_6",
        "bulge_length_at_least_7",
        "bulge_length_at_least_8",
        "bulge_length_at_least_9",
        "bulge_length_at_least_10",
        "bulge_length_at_least_11",
        "bulge_length_at_least_12",
        "bulge_length_at_least_13",
        "bulge_length_at_least_14",
        "bulge_length_at_least_15",
        "bulge_length_at_least_16",
        "bulge_length_at_least_17",
        "bulge_length_at_least_18",
        "bulge_length_at_least_19",
        "bulge_length_at_least_20",
        "bulge_length_at_least_21",
        "bulge_length_at_least_22",
        "bulge_length_at_least_23",
        "bulge_length_at_least_24",
        "bulge_length_at_least_25",
        "bulge_length_at_least_26",
        "bulge_length_at_least_27",
        "bulge_length_at_least_28",
        "bulge_length_at_least_29",
        "bulge_length_at_least_30",
        "internal_length_at_least_2",
        "internal_length_at_least_3",
        "internal_length_at_least_4",
        "internal_length_at_least_5",
        "internal_length_at_least_6",
        "internal_length_at_least_7",
        "internal_length_at_least_8",
        "internal_length_at_least_9",
        "internal_length_at_least_10",
        "internal_length_at_least_11",
        "internal_length_at_least_12",
        "internal_length_at_least_13",
        "internal_length_at_least_14",
        "internal_length_at_least_15",
        "internal_length_at_least_16",
        "internal_length_at_least_17",
        "internal_length_at_least_18",
        "internal_length_at_least_19",
        "internal_length_at_least_20",
        "internal_length_at_least_21",
        "internal_length_at_least_22",
        "internal_length_at_least_23",
        "internal_length_at_least_24",
        "internal_length_at_least_25",
        "internal_length_at_least_26",
        "internal_length_at_least_27",
        "internal_length_at_least_28",
        "internal_length_at_least_29",
        "internal_length_at_least_30",
        "internal_symmetric_length_at_least_1",
        "internal_symmetric_length_at_least_2",
        "internal_symmetric_length_at_least_3",
        "internal_symmetric_length_at_least_4",
        "internal_symmetric_length_at_least_5",
        "internal_symmetric_length_at_least_6",
        "internal_symmetric_length_at_least_7",
        "internal_symmetric_length_at_least_8",
        "internal_symmetric_length_at_least_9",
        "internal_symmetric_length_at_least_10",
        "internal_symmetric_length_at_least_11",
        "internal_symmetric_length_at_least_12",
        "internal_symmetric_length_at_least_13",
        "internal_symmetric_length_at_least_14",
        "internal_symmetric_length_at_least_15",
        "internal_asymmetry_at_least_1",
        "internal_asymmetry_at_least_2",
        "internal_asymmetry_at_least_3",
        "internal_asymmetry_at_least_4",
        "internal_asymmetry_at_least_5",
        "internal_asymmetry_at_least_6",
        "internal_asymmetry_at_least_7",
        "internal_asymmetry_at_least_8",
        "internal_asymmetry_at_least_9",
        "internal_asymmetry_at_least_10",
        "internal_asymmetry_at_least_11",
        "internal_asymmetry_at_least_12",
        "internal_asymmetry_at_least_13",
        "internal_asymmetry_at_least_14",
        "internal_asymmetry_at_least_15",
        "internal_asymmetry_at_least_16",
        "internal_asymmetry_at_least_17",
        "internal_asymmetry_at_least_18",
        "internal_asymmetry_at_least_19",
        "internal_asymmetry_at_least_20",
        "internal_asymmetry_at_least_21",
        "internal_asymmetry_at_least_22",
        "internal_asymmetry_at_least_23",
        "internal_asymmetry_at_least_24",
        "internal_asymmetry_at_least_25",
        "internal_asymmetry_at_least_26",
        "internal_asymmetry_at_least_27",
        "internal_asymmetry_at_least_28",
        "bulge_0x1_nucleotides_A",
        "bulge_0x1_nucleotides_C",
        "bulge_0x1_nucleotides_G",
        "bulge_0x1_nucleotides_U",
        "internal_1x1_nucleotides_AA",
        "internal_1x1_nucleotides_AC",
        "internal_1x1_nucleotides_AG",
        "internal_1x1_nucleotides_AU",
        "internal_1x1_nucleotides_CA",
        "internal_1x1_nucleotides_CC",
        "internal_1x1_nucleotides_CG",
        "internal_1x1_nucleotides_CU",
        "internal_1x1_nucleotides_GA",
        "internal_1x1_nucleotides_GC",
        "internal_1x1_nucleotides_GG",
        "internal_1x1_nucleotides_GU",
        "internal_1x1_nucleotides_UA",
        "internal_1x1_nucleotides_UC",
        "internal_1x1_nucleotides_UG",
        "internal_1x1_nucleotides_UU",
        "helix_stacking_AAAA",
        "helix_stacking_AAAC",
        "helix_stacking_AAAG",
        "helix_stacking_AAAU",
        "helix_stacking_AACA",
        "helix_stacking_AACC",
        "helix_stacking_AACG",
        "helix_stacking_AACU",
        "helix_stacking_AAGA",
        "helix_stacking_AAGC",
        "helix_stacking_AAGG",
        "helix_stacking_AAGU",
        "helix_stacking_AAUA",
        "helix_stacking_AAUC",
        "helix_stacking_AAUG",
        "helix_stacking_AAUU",
        "helix_stacking_ACAC",
        "helix_stacking_ACAG",
        "helix_stacking_ACAU",
        "helix_stacking_ACCA",
        "helix_stacking_ACCC",
        "helix_stacking_ACCG",
        "helix_stacking_ACCU",
        "helix_stacking_ACGA",
        "helix_stacking_ACGC",
        "helix_stacking_ACGG",
        "helix_stacking_ACGU",
        "helix_stacking_ACUA",
        "helix_stacking_ACUC",
        "helix_stacking_ACUG",
        "helix_stacking_ACUU",
        "helix_stacking_AGAC",
        "helix_stacking_AGAG",
        "helix_stacking_AGAU",
        "helix_stacking_AGCC",
        "helix_stacking_AGCG",
        "helix_stacking_AGCU",
        "helix_stacking_AGGA",
        "helix_stacking_AGGC",
        "helix_stacking_AGGG",
        "helix_stacking_AGGU",
        "helix_stacking_AGUA",
        "helix_stacking_AGUC",
        "helix_stacking_AGUG",
        "helix_stacking_AGUU",
        "helix_stacking_AUAC",
        "helix_stacking_AUAG",
        "helix_stacking_AUAU",
        "helix_stacking_AUCC",
        "helix_stacking_AUCG",
        "helix_stacking_AUCU",
        "helix_stacking_AUGC",
        "helix_stacking_AUGG",
        "helix_stacking_AUGU",
        "helix_stacking_AUUA",
        "helix_stacking_AUUC",
        "helix_stacking_AUUG",
        "helix_stacking_AUUU",
        "helix_stacking_CAAC",
        "helix_stacking_CAAG",
        "helix_stacking_CAAU",
        "helix_stacking_CACC",
        "helix_stacking_CACG",
        "helix_stacking_CACU",
        "helix_stacking_CAGC",
        "helix_stacking_CAGG",
        "helix_stacking_CAGU",
        "helix_stacking_CAUC",
        "helix_stacking_CAUG",
        "helix_stacking_CAUU",
        "helix_stacking_CCAG",
        "helix_stacking_CCAU",
        "helix_stacking_CCCC",
        "helix_stacking_CCCG",
        "helix_stacking_CCCU",
        "helix_stacking_CCGC",
        "helix_stacking_CCGG",
        "helix_stacking_CCGU",
        "helix_stacking_CCUC",
        "helix_stacking_CCUG",
        "helix_stacking_CCUU",
        "helix_stacking_CGAG",
        "helix_stacking_CGAU",
        "helix_stacking_CGCG",
        "helix_stacking_CGCU",
        "helix_stacking_CGGC",
        "helix_stacking_CGGG",
        "helix_stacking_CGGU",
        "helix_stacking_CGUC",
        "helix_stacking_CGUG",
        "helix_stacking_CGUU",
        "helix_stacking_CUAG",
        "helix_stacking_CUAU",
        "helix_stacking_CUCG",
        "helix_stacking_CUCU",
        "helix_stacking_CUGG",
        "helix_stacking_CUGU",
        "helix_stacking_CUUC",
        "helix_stacking_CUUG",
        "helix_stacking_CUUU",
        "helix_stacking_GAAG",
        "helix_stacking_GAAU",
        "helix_stacking_GACG",
        "helix_stacking_GACU",
        "helix_stacking_GAGG",
        "helix_stacking_GAGU",
        "helix_stacking_GAUG",
        "helix_stacking_GAUU",
        "helix_stacking_GCAU",
        "helix_stacking_GCCG",
        "helix_stacking_GCCU",
        "helix_stacking_GCGG",
        "helix_stacking_GCGU",
        "helix_stacking_GCUG",
        "helix_stacking_GCUU",
        "helix_stacking_GGAU",
        "helix_stacking_GGCU",
        "helix_stacking_GGGG",
        "helix_stacking_GGGU",
        "helix_stacking_GGUG",
        "helix_stacking_GGUU",
        "helix_stacking_GUAU",
        "helix_stacking_GUCU",
        "helix_stacking_GUGU",
        "helix_stacking_GUUG",
        "helix_stacking_GUUU",
        "helix_stacking_UAAU",
        "helix_stacking_UACU",
        "helix_stacking_UAGU",
        "helix_stacking_UAUU",
        "helix_stacking_UCCU",
        "helix_stacking_UCGU",
        "helix_stacking_UCUU",
        "helix_stacking_UGGU",
        "helix_stacking_UGUU",
        "helix_stacking_UUUU",
        "helix_closing_AA",
        "helix_closing_AC",
        "helix_closing_AG",
        "helix_closing_AU",
        "helix_closing_CA",
        "helix_closing_CC",
        "helix_closing_CG",
        "helix_closing_CU",
        "helix_closing_GA",
        "helix_closing_GC",
        "helix_closing_GG",
        "helix_closing_GU",
        "helix_closing_UA",
        "helix_closing_UC",
        "helix_closing_UG",
        "helix_closing_UU",
        "multi_base",
        "multi_unpaired",
        "multi_paired",
        "dangle_left_AAA",
        "dangle_left_AAC",
        "dangle_left_AAG",
        "dangle_left_AAU",
        "dangle_left_ACA",
        "dangle_left_ACC",
        "dangle_left_ACG",
        "dangle_left_ACU",
        "dangle_left_AGA",
        "dangle_left_AGC",
        "dangle_left_AGG",
        "dangle_left_AGU",
        "dangle_left_AUA",
        "dangle_left_AUC",
        "dangle_left_AUG",
        "dangle_left_AUU",
        "dangle_left_CAA",
        "dangle_left_CAC",
        "dangle_left_CAG",
        "dangle_left_CAU",
        "dangle_left_CCA",
        "dangle_left_CCC",
        "dangle_left_CCG",
        "dangle_left_CCU",
        "dangle_left_CGA",
        "dangle_left_CGC",
        "dangle_left_CGG",
        "dangle_left_CGU",
        "dangle_left_CUA",
        "dangle_left_CUC",
        "dangle_left_CUG",
        "dangle_left_CUU",
        "dangle_left_GAA",
        "dangle_left_GAC",
        "dangle_left_GAG",
        "dangle_left_GAU",
        "dangle_left_GCA",
        "dangle_left_GCC",
        "dangle_left_GCG",
        "dangle_left_GCU",
        "dangle_left_GGA",
        "dangle_left_GGC",
        "dangle_left_GGG",
        "dangle_left_GGU",
        "dangle_left_GUA",
        "dangle_left_GUC",
        "dangle_left_GUG",
        "dangle_left_GUU",
        "dangle_left_UAA",
        "dangle_left_UAC",
        "dangle_left_UAG",
        "dangle_left_UAU",
        "dangle_left_UCA",
        "dangle_left_UCC",
        "dangle_left_UCG",
        "dangle_left_UCU",
        "dangle_left_UGA",
        "dangle_left_UGC",
        "dangle_left_UGG",
        "dangle_left_UGU",
        "dangle_left_UUA",
        "dangle_left_UUC",
        "dangle_left_UUG",
        "dangle_left_UUU",
        "dangle_right_AAA",
        "dangle_right_AAC",
        "dangle_right_AAG",
        "dangle_right_AAU",
        "dangle_right_ACA",
        "dangle_right_ACC",
        "dangle_right_ACG",
        "dangle_right_ACU",
        "dangle_right_AGA",
        "dangle_right_AGC",
        "dangle_right_AGG",
        "dangle_right_AGU",
        "dangle_right_AUA",
        "dangle_right_AUC",
        "dangle_right_AUG",
        "dangle_right_AUU",
        "dangle_right_CAA",
        "dangle_right_CAC",
        "dangle_right_CAG",
        "dangle_right_CAU",
        "dangle_right_CCA",
        "dangle_right_CCC",
        "dangle_right_CCG",
        "dangle_right_CCU",
        "dangle_right_CGA",
        "dangle_right_CGC",
        "dangle_right_CGG",
        "dangle_right_CGU",
        "dangle_right_CUA",
        "dangle_right_CUC",
        "dangle_right_CUG",
        "dangle_right_CUU",
        "dangle_right_GAA",
        "dangle_right_GAC",
        "dangle_right_GAG",
        "dangle_right_GAU",
        "dangle_right_GCA",
        "dangle_right_GCC",
        "dangle_right_GCG",
        "dangle_right_GCU",
        "dangle_right_GGA",
        "dangle_right_GGC",
        "dangle_right_GGG",
        "dangle_right_GGU",
        "dangle_right_GUA",
        "dangle_right_GUC",
        "dangle_right_GUG",
        "dangle_right_GUU",
        "dangle_right_UAA",
        "dangle_right_UAC",
        "dangle_right_UAG",
        "dangle_right_UAU",
        "dangle_right_UCA",
        "dangle_right_UCC",
        "dangle_right_UCG",
        "dangle_right_UCU",
        "dangle_right_UGA",
        "dangle_right_UGC",
        "dangle_right_UGG",
        "dangle_right_UGU",
        "dangle_right_UUA",
        "dangle_right_UUC",
        "dangle_right_UUG",
        "dangle_right_UUU",
        "external_unpaired",
        "external_paired"
    };

    double default_values[714] =
    {
        0,
        0,
        0,
        0.4162915578,
        0,
        0.9612581342,
        0,
        0,
        0.01846596893,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -0.04139212902,
        -0.3640610035,
        -0.7462232056,
        -0.5816367058,
        -0.111935542,
        0.04997452372,
        -0.2197490392,
        -0.1843335711,
        0.4223289436,
        -0.3574870488,
        -0.5265534032,
        -0.932953948,
        0.411986339,
        0.1062576295,
        0.07477437513,
        0.5667786944,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.1983792337,
        -0.3555135309,
        -0.7934685894,
        -0.2288055464,
        -0.01795458178,
        -0.1688834848,
        -0.09883407825,
        -0.7814562864,
        0.863118351,
        -0.6249542685,
        -0.6249555983,
        -0.691449939,
        0.2087255478,
        -0.04445454286,
        -0.2467243301,
        -0.1313713461,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -0.1443673102,
        0.010982636,
        -0.3885136435,
        -0.8991702988,
        -0.05045391795,
        -0.3798344933,
        0.103876856,
        -0.3088575772,
        0.509866567,
        -0.9088634902,
        0.2561067468,
        -0.5402966064,
        -0.01329292414,
        0.324435051,
        -0.2378416982,
        0.5195399441,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -0.2019334758,
        -0.1071827914,
        0.432201782,
        -0.5223146358,
        0.1449335178,
        -0.3202649205,
        -0.2352551185,
        0.005466563767,
        0.4237557673,
        -0.1241687346,
        -0.1394730701,
        0.15420536,
        -0.1732104056,
        -0.344491796,
        -0.5649698219,
        -0.2161280685,
        0.1904607888,
        -0.3707351537,
        0.1569642127,
        -0.1974145872,
        -0.3843846029,
        -0.8389563479,
        0.1893394103,
        -0.4159473689,
        0.5356394643,
        -0.1743326807,
        -0.2076684426,
        -0.7948514359,
        -0.2116482499,
        0.3996959146,
        -0.4163024436,
        0.2163558888,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.4467295136,
        0.3348815656,
        -0.321028958,
        0.5446400829,
        -0.5729741077,
        -0.224208722,
        0.1996970945,
        -0.5144699437,
        0.7600072447,
        0.02634318011,
        0.2541489583,
        -0.4190229335,
        -0.137901707,
        -0.1163262975,
        0.2922737466,
        -0.1759163191,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -6.992205217,
        -2.69571999,
        0.4410457296,
        2.521423394,
        2.927402162,
        -0.5515199267,
        -0.0944079026,
        0.9085289823,
        -1.101065828,
        -0.1812708064,
        -0.0318523905,
        -0.07436397444,
        -0.7728719589,
        -0.3691743914,
        -0.3431494933,
        -0.06989429629,
        0.1421614059,
        0.2113791601,
        -0.07203614096,
        -0.1654132598,
        -0.2340327009,
        -0.1732905739,
        -0.1273138042,
        -0.111670496,
        -0.0761934088,
        -0.07322991489,
        -0.05189304201,
        -0.05740004836,
        -0.0447332794,
        -0.03491137718,
        -0.04852115898,
        -0.2320128765,
        -0.0131848564,
        -0.07434478758,
        -0.2599378975,
        -0.03052201652,
        -0.275884164,
        0.2845084459,
        -0.1454708561,
        0.1807658149,
        -0.2520873014,
        -2.029298579,
        -0.6942628632,
        -0.9383154011,
        -1.074392156,
        -0.4781139486,
        0.06007776264,
        0.2994223208,
        0.8063641144,
        -0.619935078,
        -0.7517154477,
        -0.44194688,
        -0.2804828478,
        -0.2005677545,
        -0.1316307705,
        -0.08633080395,
        -0.05132390542,
        -0.02420547319,
        0.001786445407,
        0.01594836438,
        -0.01613798162,
        -0.008487179496,
        -0.02912472811,
        -0.02126419683,
        -0.01647669009,
        -0.01337543653,
        -0.00952422195,
        -0.007461467108,
        -0.005323468885,
        -0.002592571909,
        -0.0008207963615,
        -0.3823766238,
        -0.2807996211,
        -0.2733066102,
        -0.2599656001,
        8.794619479e-05,
        -0.02149691533,
        -0.06356056512,
        0.1179747437,
        -0.1191728788,
        -0.1475031803,
        -0.2426438555,
        -0.2219120892,
        -0.02767146516,
        -0.1146044879,
        -0.02531734219,
        -0.05265031506,
        0.02057332158,
        0.04539756973,
        0.05697977983,
        -0.01383039282,
        -0.05999912417,
        -0.05943022888,
        -0.03435964735,
        -0.02895518265,
        -0.009732396765,
        -0.005368286214,
        0.007110850598,
        0.007343930496,
        0.00604365671,
        -0.3959715073,
        -0.4452311869,
        -0.7025241456,
        -0.1060859971,
        0.7789924251,
        -1.044606847,
        -0.429269817,
        0.09876943085,
        -0.3578284296,
        -0.1933431864,
        -0.1213850368,
        -0.127088721,
        -0.05746421305,
        -0.02573194757,
        -0.01043256869,
        -1.811671405,
        -0.7605490875,
        -0.629427269,
        -0.8157068585,
        -0.5216313005,
        -0.2595475438,
        0.03830519693,
        -0.04651692418,
        -0.174630357,
        0.02685443323,
        -0.1743518908,
        -0.1127115239,
        -0.03424868412,
        -0.0514917794,
        -0.05547000313,
        -0.06904807197,
        -0.05242319176,
        -0.05053274905,
        -0.03412803267,
        -0.0256729328,
        -0.01826148527,
        -0.01486624886,
        -0.0110776075,
        -0.007780319922,
        -0.005655825127,
        -0.002274331794,
        -0.0007038592001,
        -0.000348091977,
        -0.4131612095,
        -0.437891192,
        -0.1075242263,
        -0.1961871473,
        0.1815039185,
        -0.06305477118,
        -0.1976484967,
        -0.05110646604,
        -0.02622084345,
        -0.04674639957,
        0.04622249698,
        0.03518257859,
        0.04589355444,
        0.02145486819,
        -0.01940833064,
        -0.05054975061,
        -0.01676480916,
        0.0171818498,
        -0.05283189488,
        0.1731514281,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.3891146782,
        0,
        0.9527610415,
        0,
        1.326532843,
        0,
        -0.08720451568,
        0.6151025427,
        0,
        0.4676254773,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1.051903758,
        1.579644518,
        0,
        1.20081827,
        0,
        0.08852222343,
        0,
        0.8717006181,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1.09718797,
        1.324912042,
        0,
        0,
        0.5638804149,
        0.9265501934,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.1839727515,
        0,
        0.1744321674,
        -0.5123445043,
        0,
        0.8306666361,
        0,
        -0.2178263444,
        0,
        0,
        0,
        0,
        0.1277878295,
        0,
        0,
        0,
        0,
        0,
        -0.8995621825,
        0,
        0,
        -0.110734457,
        0,
        0,
        -0.4629793144,
        0,
        -1.088561215,
        -0.7884835906,
        0,
        -0.3227351871,
        0,
        -0.4450205239,
        -0.1695882837,
        -1.095187616,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -0.1122882893,
        -0.0139476919,
        0.0359076684,
        0.02980942586,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.02726602534,
        0.0124373432,
        0.1228073102,
        -0.1211376521,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        -0.1434191772,
        0.08210610957,
        0.09961757583,
        -0.1306765352,
        0,
        0,
        0,
        0,
        -0.04054243042,
        -0.004742514743,
        -0.02783379726,
        -0.02626401957,
        -0.03827791023,
        -0.01064351099,
        -0.0708318151,
        0.01449831701,
        0,
        0,
        0,
        0,
        -0.08389378212,
        0.001406424196,
        0.0848463138,
        -0.0641870235,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.02821120444,
        -0.04963184126,
        -0.07148470116,
        -0.01427939813,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.2173117947,
        -0.07543761854,
        -0.06015966892,
        -0.1734205438,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0.03892130893,
        0.02004245504,
        0.01646836679,
        -0.2021943372,
        0,
        0,
        0,
        0,
        -0.04417953596,
        -0.02529092887,
        -0.04456455424,
        -0.01294223942,
        -0.05744404444,
        0.03281894881,
        -0.120648277,
        -0.01802376253,
        0,
        0,
        0,
        0,
        0.01660955039,
        -0.003439635346,
        -0.04792943035,
        -0.0384234448,
        0,
        0,
        0,
        0,
        0.002489378316,
        -0.000125046326
    };

    for (size_t i = 0; i < 714; i++)
        params[default_names[i]] = default_values[i];

    std::vector<double> values(names.size());
    for (size_t i = 0; i < names.size(); i++)
    {
        std::map<std::string, double>::iterator iter = params.find(names[i]);
        if (iter == params.end())
            Error("Default parameter file missing parameter: %s", names[i].c_str());
        values[i] = iter->second;
        params.erase(iter);
    }

    for (std::map<std::string, double>::iterator iter = params.begin(); iter != params.end(); ++iter)
        Warning("Default parameter file contains extra parameter: %s", iter->first.c_str());

    return values;
}
