/////////////////////////////////////////////////////////////////
// FileDescription.cpp
/////////////////////////////////////////////////////////////////

#include "FileDescription.hpp"

/////////////////////////////////////////////////////////////////
// FileDescription::FileDescription()
// FileDescription::~FileDescription()
//
// Default constructor and destructor.
/////////////////////////////////////////////////////////////////

FileDescription::FileDescription() {}
FileDescription::~FileDescription() {}

/////////////////////////////////////////////////////////////////
// FileDescription::FileDescription()
//
// Copy constructor.
/////////////////////////////////////////////////////////////////

FileDescription::FileDescription(const FileDescription &rhs) :
    input_filename(rhs.input_filename), 
    output_parens_filename(rhs.output_parens_filename),
    output_bpseq_filename(rhs.output_bpseq_filename),
    output_posteriors_filename(rhs.output_posteriors_filename),
    size(rhs.size), weight(rhs.weight)
{}

/////////////////////////////////////////////////////////////////
// FileDescription::operator=
//
// Assignment operator.
/////////////////////////////////////////////////////////////////

FileDescription &FileDescription::operator=(const FileDescription &rhs)
{
    if (this != &rhs)
    {
        input_filename = rhs.input_filename;
        output_parens_filename = rhs.output_parens_filename;
        output_bpseq_filename = rhs.output_bpseq_filename;
        output_posteriors_filename = rhs.output_posteriors_filename;
        size = rhs.size;
        weight = rhs.weight;
    }
    return *this;
}
